/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.jdbc;

public class OldRepository {

//    private static final Log log = LogFactory.getLog(Repository.class);
//
//    /**
//     * Data source for obtaining database connections. Media type handlers need to access the
//     * database for performing almost all the tasks.
//     */
//    protected DataSource dataSource;
//
//    /**
//     * User manager realm, which can be used to set permissions on resources. Media type handlers
//     * may want to add other resources (e.g. imports) than the originally given resource. So it is
//     * necessary to allow media type handler to set permissions for the resources it is dealing
//     * with.
//     */
//    protected UserRealm realm;
//
//    /** ResourceDAO for directly accessing resources. */
//    private VersionedResourceDAO resourceDAO = new VersionedResourceDAO(dataSource);
//
//    public OldRepository(DataSource dataSource, UserRealm userRealm) {
//        this.dataSource = dataSource;
//        this.realm = userRealm;
//    }
//
//    public Resource get(String path) throws RegistryException {
//
//        ResourceImpl resourceImpl;
//
//        String plainPath = path;
//        long versionNumber = -1;
//        if (path.indexOf("?v=") != -1) {
//            String[] parts = path.split("\\?v=");
//            plainPath = parts[0];
//            versionNumber = Long.parseLong(parts[1]);
//        }
//
//        plainPath = getPreparedPath(plainPath);
//
//        Connection conn;
//        try {
//            conn = dataSource.getConnection();
//        } catch (SQLException e) {
//            throw new RegistryException(e.getMessage());
//        }
//        //if we uncomment following three lines then , no onc access a deleted resourceImpl
////        if (!resourceDAO.isResourceActive(plainPath,conn)) {
////             throw new RegistryException("Trying to access a deleted resourceImpl");
////        }
//        try {
//            //resourceImpl = resourceDAO.get(path, conn);
//            if (versionNumber == -1) {
//                resourceImpl = resourceDAO.getLatestVersion(plainPath, conn);
//
//            } else {
//                resourceImpl = resourceDAO.get(plainPath, versionNumber, conn);
//            }
//
//            if (resourceImpl != null) {
//                resourceImpl.setDataSource(dataSource);
//            }
//
//        } catch (Exception e) {
//
//            String msg = Messages.getMessage("resource.get.fail", path);
//            log.error(msg, e);
//            throw new RegistryException(msg);
//
//        } finally {
//            try {
//                conn.close();
//            } catch (SQLException e) {
//                e.printStackTrace();
//            }
//        }
//
//        // we are just getting the content from the database. not a content modification.
//        if (resourceImpl != null && resourceImpl instanceof ResourceImpl) {
//            resourceImpl.setContentModified(false);
//        }
//
//        return resourceImpl;
//    }
//
//    public boolean put(String path, Resource resource) throws RegistryException {
//
//        String preparedPath = getPreparedPath(path);
//
//        String userID = CurrentSession.getUser();
//
//        if (!(resource instanceof ResourceImpl)) {
//            String msg = "Only the ResourceImpl instances " +
//                    "are supported in the org.wso2.registry.jdbc.Repository.";
//            throw new RegistryException(msg);
//        }
//
//        ResourceImpl resourceImpl = (ResourceImpl) resource;
//
//        Connection conn;
//        try {
//            conn = dataSource.getConnection();
//        } catch (SQLException e) {
//            throw new RegistryException(e.getMessage());
//        }
//
//        try {
//            conn.setAutoCommit(false);
//
//            ResourceImpl a = resourceDAO.getLatestVersion(preparedPath, conn);
//            if (a != null) {
//
//                // if the parent collections of this resource are in deleted state, make them
//                // activated
//                activateParentCollections(preparedPath, conn);
//
//                // given resource already exist. update it.
//                resourceImpl.setId(a.getId());
//
//                // if client has not explicitly set the author, keep the original author name.
//                if (resource.getAuthorUserName() == null) {
//                    resourceImpl.setAuthorUserName(a.getAuthorUserName());
//                }
//                resourceImpl.setPath(preparedPath);
//                resourceImpl.setState(RegistryConstants.ACTIVE_STATE);
//                resourceImpl.setLastUpdaterUserName(userID);
//                resourceDAO.update(preparedPath, resourceImpl, conn);
//                if (resourceImpl.isDirectory()) {
//                    if (!a.isDirectory()) {
//                        throw new RegistryException("Trying to add a collection while a " +
//                                                    "resource with the same name exist in the system");
//                    }
//                } else {
//                    if (a.isDirectory()) {
//                        throw new RegistryException("Trying to add a resource while a " +
//                                                    "collection with the same name exist in the system");
//                    }
//                }
//
//                if (resourceImpl.isContentModified() ||
//                    a.getState() == RegistryConstants.DELETED_STATE) {
//                    resourceDAO.addResourceVersion(resourceImpl, conn);
//                }
//
//                long resourceID = resourceDAO.getResourceID(preparedPath, conn);
//                long currentVersion = resourceDAO.getCurrentVersionNumber(preparedPath, conn);
//                resourceDAO.addDependencies(
//                        resourceID, currentVersion, resource.getDependencies(), conn);
//
//            } else {
//
//                // given resource does not exist. add it as a new resource.
//
//                // first create all ascendant collections
//                createParentCollections(preparedPath, conn, userID);
//
//                // now add the required resource
//                resourceImpl.setPath(preparedPath);
//                if (resource.getAuthorUserName() == null) {
//                    resourceImpl.setAuthorUserName(userID);
//                }
//                resourceImpl.setLastUpdaterUserName(userID);
//
//                resourceDAO.add(resourceImpl, conn);
//                AuthorizationUtil.setDefaultAuthorizations(realm, preparedPath, userID);
//
//                resourceImpl.setId(resourceDAO.getResourceID(preparedPath, conn));
//                resourceDAO.addResourceVersion(resourceImpl, conn);
//
//                long resourceID = resourceDAO.getResourceID(preparedPath, conn);
//                long currentVersion = resourceDAO.getCurrentVersionNumber(preparedPath, conn);
//                resourceDAO.addDependencies(
//                        resourceID, currentVersion, resource.getDependencies(), conn);
//            }
//
//            conn.commit();
//
//        } catch (Exception e) {
//
//            try {
//                conn.rollbackTransaction();
//            } catch (SQLException e1) {
//                e1.printStackTrace();
//            }
//
//            String msg = Messages.getMessage("resource.put.fail", preparedPath, e.getMessage());
//            log.error(msg, e);
//            throw new RegistryException(msg);
//        } finally {
//            try {
//                conn.close();
//            } catch (SQLException e) {
//                log.error("Exception occur in side the finaly block of " + this + " put");
//            }
//        }
//        return true;
//    }
//
//    /**
//     * This method will first split the given path and then try to create directory for each part
//     * for example if the path is "/abc/xyx/r1" , then first it will see whether the resource "/abc"
//     * is there if it is not there then it will create that else go to "/abc/xyz" , and see whether
//     * the resource is there , if so continue the same procedure
//     *
//     * @param path   : Location where we need to add the resource
//     * @param conn   : DB connection
//     * @param userID : user
//     * @throws SQLException      : Something went wrong
//     * @throws RegistryException : Something went wrong
//     */
//    private void createParentCollections(String path,
//                                         Connection conn,
//                                         String userID)
//            throws SQLException, IOException, RegistryException {
//
//        String[] parts = path.split(RegistryConstants.PATH_SEPARATOR);
//
//        String currentPath = RegistryConstants.ROOT_PATH + parts[1];
//        for (int i = 2; i < parts.length; i++) {
//
//            ResourceImpl currentCollection = resourceDAO.getLatestVersion(currentPath, conn);
//            if (currentCollection == null) {
//                currentCollection = new CollectionImpl();
//                currentCollection.setPath(currentPath);
//                currentCollection.setAuthorUserName(userID);
//                currentCollection.setLastUpdaterUserName(userID);
//
//                resourceDAO.add(currentCollection, conn);
//                AuthorizationUtil.setDefaultAuthorizations(realm, currentPath, userID);
////                        currentCollection = resourceDAO.getLatestVersion(currentPath, conn);
//
//            } else {
//
//                if (currentCollection.getState() == RegistryConstants.DELETED_STATE) {
//
//                    //currentCollection = new Resource();
//                    //currentCollection.setPath(currentPath);
//                    //currentCollection.setDirectory(true);
//                    //currentCollection.setAuthorUserName(userID);
//                    //currentCollection.setLastUpdaterUserName(userID);
//                    resourceDAO.markActivated(currentCollection.getId(), conn);
//                    //put(currentPath, currentCollection);
//
//                } else if (!currentCollection.isDirectory()) {
//
//                    String message =
//                            Messages.getMessage("resource.adding.error", currentPath, path);
//                    throw new RegistryException(message);
//                }
//            }
//
//            currentPath = currentPath + RegistryConstants.PATH_SEPARATOR + parts[i];
//        }
//    }
//
//    private void activateParentCollections(String path,
//                                           Connection conn)
//            throws SQLException, IOException, RegistryException {
//
//        if (path.equals(RegistryConstants.ROOT_PATH)) {
//            // if we are at root, there are no parent collections.
//            return;
//        }
//
//        String[] parts = path.split(RegistryConstants.PATH_SEPARATOR);
//
//        String currentPath = RegistryConstants.ROOT_PATH + parts[1];
//        for (int i = 2; i < parts.length; i++) {
//
//            ResourceImpl currentCollection = resourceDAO.getLatestVersion(currentPath, conn);
//            if (currentCollection == null) {
//
//                String msg = "Parent collection: " + currentPath + " of the exsiting resource:" +
//                             path + " cannot be null";
//                log.error(msg);
//                throw new RegistryException(msg);
//
//            } else {
//
//                if (currentCollection.getState() == RegistryConstants.DELETED_STATE) {
//
//                    resourceDAO.markActivated(currentCollection.getId(), conn);
//
//                } else if (!currentCollection.isDirectory()) {
//
//                    String msg = "Parent : " + currentPath + " of the exsiting resource:" + path +
//                                 " should be a collection resource.";
//                    log.error(msg);
//                    throw new RegistryException(msg);
//                }
//            }
//
//            currentPath = currentPath + RegistryConstants.PATH_SEPARATOR + parts[i];
//        }
//    }
//
//    public String importResource(String path, String sourceURL, Resource metadata)
//            throws RegistryException {
//
//        String preparedPath = getPreparedPath(path);
//
//        URL url;
//        try {
//            url = new URL(sourceURL);
//        } catch (MalformedURLException e) {
//            String msg = "Given source URL is not valid.";
//            throw new RegistryException(msg, e);
//        }
//
//        try {
//            URLConnection uc = url.openConnection();
//            InputStream in = uc.getInputStream();
//
//            //ByteArrayOutputStream out = new ByteArrayOutputStream();
//            //byte[] buffer = new byte[1024];
//            //int c;
//            //while ((c = in.read(buffer)) != -1) {
//            //    out.write(buffer, 0, c);
//            //}
//            //out.flush();
//
//            ResourceImpl resource = new ResourceImpl();
//            resource.setPath(preparedPath);
//            String mediaType = metadata.getMediaType();
//            if (mediaType == null)
//                mediaType = uc.getContentType();
//            resource.setMediaType(mediaType);
//            resource.setDescription(metadata.getDescription());
//            resource.setContentStream(in);
//
//            put(preparedPath, resource);
//
//        } catch (IOException e) {
//            String msg = "Could not read from the given URL: " + sourceURL;
//            throw new RegistryException(msg, e);
//        }
//        return preparedPath;
//    }
//
//    public boolean delete(String path) throws RegistryException {
//
//        String preparedPath = getPreparedPath(path);
//
//        Connection conn;
//        try {
//            conn = dataSource.getConnection();
//        } catch (SQLException e) {
//            throw new RegistryException(e.getMessage());
//        }
//
//        try {
//            conn.setAutoCommit(false);
//            ResourceImpl resource = resourceDAO.getLatestVersion(preparedPath, conn);
//            if (resource != null) {
//                if (resource.isDirectory()) {
//                    deleteDirectory(resource, conn);
//                } else {
//                    resourceDAO.markDeleted(preparedPath, conn);
//                    resourceDAO.deleteResource(resource, conn);
//                    //prepareToDelete(resource.getId(), conn);
//                    //resourceDAO.delete(resource.getResourcePath(), conn);
//                }
//            } else {
//                String msg = Messages.getMessage("delete.null.resource", preparedPath);
//                log.error(msg);
//                throw new RegistryException(msg);
//            }
//            conn.commit();
//        } catch (Exception e) {
//            try {
//                conn.rollbackTransaction();
//            } catch (SQLException e1) {
//                log.error("Exception occur in side the catch block of " + this + " delete");
//            }
//            String msg = Messages.getMessage("resource.delete.fail", preparedPath);
//            log.error(msg, e);
//            throw new RegistryException(msg);
//        } finally {
//            try {
//                conn.close();
//            } catch (SQLException e) {
//                log.error("Exception occur in side the finaly block of " + this + " delete");
//            }
//        }
//        return true;
//    }
//
//    private void deleteDirectory(ResourceImpl collection, Connection conn)
//            throws SQLException, IOException, RegistryException {
//        List childList = resourceDAO.getChildren(collection.getId(), -1, conn);
//        Iterator i = childList.iterator();
//        while (i.hasNext()) {
//            ResourceImpl child = (ResourceImpl)i.next();
////            if (child.isDirectory()) {
////                deleteDirectory(child, conn);
////            } else {
//            resourceDAO.markDeleted(child.getPath(), conn);
//            resourceDAO.deleteResource(child, conn);
////            }
//        }
//        resourceDAO.markDeleted(collection.getPath(), conn);
//        resourceDAO.deleteResource(collection, conn);
//    }
//
//    public boolean putChild(String childPath, Resource resource) throws RegistryException {
//        // General resource should not have any constraint on adding children.
//        return true;
//    }
//
//    public boolean importChild(String childPath, String sourceURL) throws RegistryException {
//        return true;
//    }
//
//    private String getPreparedPath(String resourcePath) {
//
//        String preparedPath = resourcePath;
//        if (preparedPath.equals(RegistryConstants.ROOT_PATH)) {
//            return preparedPath;
//
//        } else {
//
//            if (!preparedPath.startsWith(RegistryConstants.ROOT_PATH)) {
//                preparedPath = RegistryConstants.ROOT_PATH + preparedPath;
//            }
//
//            if (preparedPath.endsWith(RegistryConstants.PATH_SEPARATOR)) {
//                preparedPath = preparedPath.substring(0, preparedPath.length() - 1);
//            }
//        }
//
//        return preparedPath;
//    }
}
