/*
 * Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.jdbc.dao;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.wso2.registry.*;
import org.wso2.registry.Collection;
import org.wso2.registry.jdbc.DatabaseConstants;
import org.wso2.registry.users.UserRealm;
import org.wso2.registry.utils.AuthorizationUtil;

import javax.activation.DataHandler;
import javax.sql.DataSource;
import java.io.*;
import java.sql.*;
import java.sql.Date;
import java.util.*;

public class VersionedResourceDAO {

//<<<<<<< .mine
//    private static final Log log = LogFactory.getLog(VersionedResourceDAO.class);
//
//    private DataSource dataSource;
//
//    public VersionedResourceDAO(DataSource dataSource) {
//        this.dataSource = dataSource;
//    }
//
//    /**
//     * Returns the given version of the artifact. If artifact is a collection all child paths will
//     * be added as versioned paths in the form /a/b?v=12
//     *
//     * @param path          : path of the artifact
//     * @param versionNumber : Version number
//     * @param conn          : Connection to DB
//     * @return Resource for the given version number
//     * @throws SQLException : If something went wrong
//     */
//    public ResourceImpl get(String path, long versionNumber, Connection conn)
//            throws SQLException, IOException {
//
//        ResourceImpl resource = null;
//
//        ResultSet result;
//
//        // get the resource data from the resource table
//
//        String sql = "SELECT * FROM ARTIFACTS A WHERE A.PATH=?";
//        PreparedStatement statement = conn.prepareStatement(sql);
//        statement.setString(1, path);
//
//        result = statement.executeQuery();
//
//        if (result.next()) {
//            resource = result.getInt(DatabaseConstants.DIRECTORY_FIELD) == 1 ?
//                    new CollectionImpl() : new ResourceImpl();
//
//            resource.setId(result.getLong(DatabaseConstants.AID_FIELD));
//            resource.setPath(path + "?v=" + versionNumber);
//            resource.setParentPath(getParentPath(resource.getId(), versionNumber, conn));
//            resource.setMediaType(result.getString(DatabaseConstants.MEDIA_TYPE_FIELD));
//            resource.setState(result.getInt(DatabaseConstants.STATE_FIELD));
//            resource.setAuthorUserName(result.getString(DatabaseConstants.AUTHOR_FIELD));
//            resource.setCreatedTime(result.getTimestamp(DatabaseConstants.CREATED_TIME_FIELD));
//            resource.setDescription(result.getString(DatabaseConstants.DESCRIPTION_FIELD));
//        }
//
//        if (resource == null) {
//            return null;
//        }
//
//        String sqlVersionedFields = "SELECT * FROM VERSIONS WHERE AID=? AND VN=?";
//        PreparedStatement versionQuery = conn.prepareStatement(sqlVersionedFields);
//        versionQuery.setLong(1, resource.getId());
//        versionQuery.setLong(2, versionNumber);
//
//        ResultSet versionResults = versionQuery.executeQuery();
//
//        if (versionResults.next()) {
//            resource.setVersionNumber(
//                    versionResults.getLong(DatabaseConstants.VERSION_NUMBER_FIELD));
//            resource.setLastUpdaterUserName(
//                    versionResults.getString(DatabaseConstants.VERSION_AUTHOR_FIELD));
//            resource.setLastModified(
//                    versionResults.getTimestamp(DatabaseConstants.VERSION_UPDATED_TIME));
//
//            // set the datasource to fetch the content.
//            resource.setDataSource(dataSource);
//
//            //resource.setContentStream(getDisconnectedStream(
//            //        versionResults.getBinaryStream(DatabaseConstants.VERSION_CONTENT_FIELD)));
//        }
//
//        // get resource children
//
//        if (resource.isDirectory()) {
//            String[] children = getChildPaths(resource.getId(), versionNumber, conn);
//            resource.setContent(children);
//        }
//
//        resource.setDependencies(getDependencies(resource.getId(), versionNumber, conn));
//        resource.setDependents(getDependents(resource.getId(), versionNumber, conn));
//
//        // get resource properties
//        return getResourceWithProperties(conn, resource);
//    }
//
//    public ResourceImpl getResourceByID(
//            long artifactID, long versionNumber, Connection conn)
//            throws SQLException, IOException {
//
//        ResourceImpl resource = null;
//
//        ResultSet result;
//
//        // get the resource data from the resource table
//
//        String sql = "SELECT * FROM ARTIFACTS A WHERE A.AID=?";
//        PreparedStatement statement = conn.prepareStatement(sql);
//        statement.setLong(1, artifactID);
//
//        result = statement.executeQuery();
//
//        if (result.next()) {
//            final boolean isDirectory = result.getInt(DatabaseConstants.DIRECTORY_FIELD) == 1;
//            resource = isDirectory ? new CollectionImpl() : new ResourceImpl();
//
//            resource.setId(result.getLong(DatabaseConstants.AID_FIELD));
//            resource.setPath(result.getString(DatabaseConstants.PATH_FIELD));
//            resource.setMediaType(result.getString(DatabaseConstants.MEDIA_TYPE_FIELD));
//            resource.setState(result.getInt(DatabaseConstants.STATE_FIELD));
//            resource.setAuthorUserName(result.getString(DatabaseConstants.AUTHOR_FIELD));
//            resource.setCreatedTime(result.getTimestamp(DatabaseConstants.CREATED_TIME_FIELD));
//            resource.setDescription(result.getString(DatabaseConstants.DESCRIPTION_FIELD));
//        }
//
//        if (resource == null) {
//            return null;
//        }
//
////        boolean latestVerions = false;
//        if (versionNumber == -1) {
////            latestVerions = true;
//            versionNumber = getLatestVersionNumber(artifactID, conn);
//        }
//        String sqlVersionedFields = "SELECT * FROM VERSIONS WHERE AID=? AND VN=?";
//        PreparedStatement versionQuery = conn.prepareStatement(sqlVersionedFields);
//        versionQuery.setLong(1, resource.getId());
//        versionQuery.setLong(2, versionNumber);
//
//        ResultSet versionResults = versionQuery.executeQuery();
//
//        if (versionResults.next()) {
//            resource.setVersionNumber(
//                    versionResults.getLong(DatabaseConstants.VERSION_NUMBER_FIELD));
//            resource.setLastUpdaterUserName(
//                    versionResults.getString(DatabaseConstants.VERSION_AUTHOR_FIELD));
//            resource.setLastModified(
//                    versionResults.getTimestamp(DatabaseConstants.VERSION_UPDATED_TIME));
//
//            // set the datasource to fetch the content.
//            resource.setDataSource(dataSource);
//
//            //resource.setContentStream(getDisconnectedStream(
//            //        versionResults.getBinaryStream(DatabaseConstants.VERSION_CONTENT_FIELD)));
//        }
//
//        // get resource children
//
//        if (resource.isDirectory()) {
//
//            String[] children = getChildPaths(resource.getId(), versionNumber, conn);
//            resource.setContent(children);
//        }
//
//        // get resource properties
//        resource.setDependencies(getDependencies(resource.getId(), versionNumber, conn));
//        resource.setDependents(getDependents(resource.getId(), versionNumber, conn));
//        return getResourceWithProperties(conn, resource);
//    }
//
//    public InputStream getResourceContentStream(
//            long resourceID, long versionNumber, Connection conn)
//            throws SQLException, IOException {
//
//        if (versionNumber == -1) {
//            versionNumber = getLatestVersionNumber(resourceID, conn);
//        }
//
//        String sqlVersionedFields = "SELECT * FROM VERSIONS WHERE AID=? AND VN=?";
//        PreparedStatement versionQuery = conn.prepareStatement(sqlVersionedFields);
//        versionQuery.setLong(1, resourceID);
//        versionQuery.setLong(2, versionNumber);
//
//        ResultSet versionResults = versionQuery.executeQuery();
//
//        InputStream contentStream = null;
//        if (versionResults.next()) {
//            contentStream = getDisconnectedStream(
//                    versionResults.getBinaryStream(DatabaseConstants.VERSION_CONTENT_FIELD));
//        }
//
//        return contentStream;
//    }
//
//    private ResourceImpl getResourceWithProperties(Connection conn, ResourceImpl resource)
//            throws SQLException {
//        String propSQL = "SELECT P.PKEY, P.PVALUE FROM PROPERTIES P WHERE P.AID=?";
//        PreparedStatement s3 = conn.prepareStatement(propSQL);
//        s3.setLong(1, resource.getId());
//        ResultSet propResults = s3.executeQuery();
//
//        //Properties props = new Properties();
//        while (propResults.next()) {
//            String key = propResults.getString(DatabaseConstants.PROPERTY_KEY_FIELD);
//            String value = propResults.getString(DatabaseConstants.PROPERTY_VALUE_FIELD);
//            resource.addProperty(key, value);
//            //props.put(key, value);
//        }
//        //resource.setProperties(props);
//
//        return resource;
//    }
//
//    private String[] getDependencies(long resourceID, long version, Connection conn)
//            throws SQLException {
//
//        String depSQL = "SELECT A.PATH, D.DAID, D.DVN FROM ARTIFACTS A, DEPENDENCY_MANAGEMENT D " +
//                "WHERE D.AID=? AND D.VN=? AND D.DTYPE=? AND A.AID=D.DAID";
//
//        PreparedStatement depSt = conn.prepareStatement(depSQL);
//        depSt.setLong(1, resourceID);
//        depSt.setLong(2, version);
//        depSt.setString(3, RegistryConstants.DEFAULT_DEPENDENCY);
//
//        List<String> depList = new ArrayList();
//        ResultSet depResults = depSt.executeQuery();
//        while (depResults.next()) {
//            String dependencyPath = depResults.getString(DatabaseConstants.PATH_FIELD);
//            long dependencyVersion = depResults.getLong("DVN");
//            String fullDependencyPath = dependencyPath + "?v=" + dependencyVersion;
//
//            depList.add(fullDependencyPath);
//        }
//
//        depResults.close();
//
//        return depList.toArray(new String[depList.size()]);
//    }
//
//    private DependencyChain[] getOneLevelDependencies(long resourceID,
//                                                      long version,
//                                                      Connection conn)
//            throws SQLException {
//
//        String depSQL = "SELECT A.PATH, D.DAID, D.DVN FROM ARTIFACTS A, DEPENDENCY_MANAGEMENT D " +
//                "WHERE D.AID=? AND D.VN=? AND D.DTYPE=? AND A.AID=D.DAID";
//
//        PreparedStatement depSt = conn.prepareStatement(depSQL);
//        depSt.setLong(1, resourceID);
//        depSt.setLong(2, version);
//        depSt.setString(3, RegistryConstants.DEFAULT_DEPENDENCY);
//
//        List<DependencyChain> depList = new ArrayList();
//        ResultSet depResults = depSt.executeQuery();
//        while (depResults.next()) {
//            String dependencyPath = depResults.getString(DatabaseConstants.PATH_FIELD);
//            long dependencyVersion = depResults.getLong("DVN");
//            String fullDependencyPath = dependencyPath + "?v=" + dependencyVersion;
//
//            DependencyChain dependency = new DependencyChain();
//            dependency.setDependencyPath(fullDependencyPath);
//            depList.add(dependency);
//        }
//
//        depResults.close();
//
//        return depList.toArray(new DependencyChain[depList.size()]);
//    }
//
//    public DependencyChain[] getDependencies(String resourcePath, Connection conn)
//            throws SQLException, RegistryException {
//
//        VersionedPath versionedPath = RegistryUtils.getVersionedPath(resourcePath);
//
//        if (versionedPath.getVersion() == -1) {
//            versionedPath.setVersion(getCurrentVersionNumber(versionedPath.getPath(), conn));
//        }
//        long resourceID = getResourceID(versionedPath.getPath(), conn);
//
//        DependencyChain[] dependencies =
//                getOneLevelDependencies(resourceID, versionedPath.getVersion(), conn);
//
//        for (DependencyChain dependency : dependencies) {
//            DependencyChain[] sDependencies = getDependencies(dependency.getDependencyPath(), conn);
//            dependency.setDependencies(sDependencies);
//        }
//
//        return dependencies;
//    }
//
//    private String[] getDependents(long resourceID, long version, Connection conn)
//            throws SQLException {
//
//        String depSQL = "SELECT A.PATH, D.AID, D.VN FROM ARTIFACTS A, DEPENDENCY_MANAGEMENT D " +
//                "WHERE D.DAID=? AND D.DVN=? AND D.DTYPE=? AND A.AID=D.AID";
//
//        PreparedStatement depSt = conn.prepareStatement(depSQL);
//        depSt.setLong(1, resourceID);
//        depSt.setLong(2, version);
//        depSt.setString(3, RegistryConstants.DEFAULT_DEPENDENCY);
//
//        List<String> depList = new ArrayList();
//        ResultSet depResults = depSt.executeQuery();
//        while (depResults.next()) {
//            String dependentPath = depResults.getString(DatabaseConstants.PATH_FIELD);
//            long dependentVersion = depResults.getLong("VN");
//            String fullDependentPath = dependentPath + "?v=" + dependentVersion;
//
//            depList.add(fullDependentPath);
//        }
//
//        depResults.close();
//
//        return depList.toArray(new String[depList.size()]);
//    }
//
//    private DependentChain[] getOneLevelDependents(long resourceID, long version, Connection conn)
//            throws SQLException {
//
//        String depSQL = "SELECT A.PATH, D.AID, D.VN FROM ARTIFACTS A, DEPENDENCY_MANAGEMENT D " +
//                "WHERE D.DAID=? AND D.DVN=? AND D.DTYPE=? AND A.AID=D.AID";
//
//        PreparedStatement depSt = conn.prepareStatement(depSQL);
//        depSt.setLong(1, resourceID);
//        depSt.setLong(2, version);
//        depSt.setString(3, RegistryConstants.DEFAULT_DEPENDENCY);
//
//        List<DependentChain> depList = new ArrayList();
//        ResultSet depResults = depSt.executeQuery();
//        while (depResults.next()) {
//            String dependentPath = depResults.getString(DatabaseConstants.PATH_FIELD);
//            long dependentVersion = depResults.getLong("VN");
//            String fullDependentPath = dependentPath + "?v=" + dependentVersion;
//
//            DependentChain dependents = new DependentChain();
//            dependents.setDependentPath(fullDependentPath);
//            depList.add(dependents);
//        }
//
//        depResults.close();
//
//        return depList.toArray(new DependentChain[depList.size()]);
//    }
//
//    public DependentChain[] getDependents(String resourcePath, Connection conn)
//            throws SQLException, RegistryException {
//
//        VersionedPath versionedPath = RegistryUtils.getVersionedPath(resourcePath);
//
//        if (versionedPath.getVersion() == -1) {
//            versionedPath.setVersion(getCurrentVersionNumber(versionedPath.getPath(), conn));
//        }
//        long resourceID = getResourceID(versionedPath.getPath(), conn);
//
//        DependentChain[] dependents =
//                getOneLevelDependents(resourceID, versionedPath.getVersion(), conn);
//
//        for (DependentChain dependent : dependents) {
//            DependentChain[] sDependents = getDependents(dependent.getDependentPath(), conn);
//            dependent.setDependents(sDependents);
//        }
//
//        return dependents;
//    }
//
//    /**
//     * Returns the latest (current) version of an artifact. If artifact is a collection, all child
//     * paths will be added as latest paths in the form /a/b
//     *
//     * @param path : path of the artifact
//     * @param conn :Connection to DB
//     * @return : Result artifact
//     * @throws SQLException : if something went wrong
//     */
//    public ResourceImpl getLatestVersion(String path, Connection conn)
//            throws RegistryException, SQLException, IOException {
//        /*
//        * when someone give path like "root/wso2/wsas/r1" , then need to figure out the latest
//        * version of the root and from the need to figure out the version of wso2 and so so
//        * so when list outing the nodes need to give them correctly.
//        * */
//
//        ResourceImpl resource;
//
//        ResultSet result;
//
//        // get the resource data from the resource table
//
//        String sql = "SELECT * FROM ARTIFACTS A WHERE A.PATH=?";
//        PreparedStatement statement = conn.prepareStatement(sql);
//        statement.setString(1, path);
//
//        result = statement.executeQuery();
//
//        if (!result.next())
//            return null;
//
//        final boolean isDirectory = result.getInt(DatabaseConstants.DIRECTORY_FIELD) == 1;
//        resource = isDirectory ? new CollectionImpl() : new ResourceImpl();
//
//        resource.setId(result.getLong(DatabaseConstants.AID_FIELD));
//        resource.setPath(result.getString(DatabaseConstants.PATH_FIELD));
//        resource.setParentPath(getParentPath(resource.getPath()));
//        resource.setMediaType(result.getString(DatabaseConstants.MEDIA_TYPE_FIELD));
//        resource.setState(result.getInt(DatabaseConstants.STATE_FIELD));
//        resource.setAuthorUserName(result.getString(DatabaseConstants.AUTHOR_FIELD));
//        resource.setCreatedTime(result.getTimestamp(DatabaseConstants.CREATED_TIME_FIELD));
//        resource.setDescription(result.getString(DatabaseConstants.DESCRIPTION_FIELD));
//
////        long latestVersionNumber = getLatestVersionNumber(resource.getId(), conn);
//        long latestVersionNumber = getCurrentVersionNumber(resource.getPath(), conn);
//
//        String sqlVersionedFields = "SELECT * FROM VERSIONS WHERE AID=? AND VN=?";
//        PreparedStatement versionQuery = conn.prepareStatement(sqlVersionedFields);
//        versionQuery.setLong(1, resource.getId());
//        versionQuery.setLong(2, latestVersionNumber);
//
//        ResultSet versionResults = versionQuery.executeQuery();
//
//        if (versionResults.next()) {
//            resource.setVersionNumber(
//                    versionResults.getLong(DatabaseConstants.VERSION_NUMBER_FIELD));
//            resource.setLastUpdaterUserName(
//                    versionResults.getString(DatabaseConstants.VERSION_AUTHOR_FIELD));
//            resource.setLastModified(
//                    versionResults.getTimestamp(DatabaseConstants.VERSION_UPDATED_TIME));
//
//            // set the datasource to fetch the content.
//            resource.setDataSource(dataSource);
//
//            //if (!isDirectory) {
//            //    resource.setContentStream(getDisconnectedStream(
//            //            versionResults.getBinaryStream(DatabaseConstants.VERSION_CONTENT_FIELD)));
//            //}
//        }
//
//        // get resource children
//        if (resource.isDirectory()) {
//            String[] children = getLatestChildPaths(resource.getId(),
//                    getCurrentVersionNumber(path, conn), conn);
//            resource.setContent(children);
//        }
//
//        resource.setDependencies(getDependencies(resource.getId(), latestVersionNumber, conn));
//        resource.setDependents(getDependents(resource.getId(), latestVersionNumber, conn));
//
//        // get resource properties
//        return getResourceWithProperties(conn, resource);
//    }
//
//    /**
//     * To get the current version for a give resource , current version may not be the latest
//     * version in all the cases. If someone restore a resource then the child nodes will remain same
//     * But the parent version will be changed. In that case the parent [foo/bar] version will be the
//     * latest version but the child node version [foo/bar/v1] will be an old version . So when some
//     * one ask for the resource value foo/bar/v1 then we need to calculate them correctly and give
//     * that.
//     *
//     * @param path : Resource ID
//     * @param conn : Connection to DB
//     * @return : verion number of the resource user requested
//     */
//    public long getCurrentVersionNumber(String path, Connection conn) throws RegistryException {
//        if (path != null) {
//            try {
//                String[] parts = path.split(RegistryConstants.PATH_SEPARATOR);
//                if (parts.length > 1) {
//                    String currentPath = RegistryConstants.ROOT_PATH + parts[1];
//                    String parentPath = RegistryConstants.ROOT_PATH;
//                    long parentVersion = getLatestVersionNumber(
//                            getResourceID(RegistryConstants.ROOT_PATH, conn), conn);
//                    long childId = 1;
//                    for (int i = 2; i < parts.length; i++) {
//                        if (!resourceActive(parentPath, conn)) {
//                            throw new RegistryException("Resource is not active");
//                        }
//                        long parentId = getResourceID(parentPath, conn);
//                        childId = getResourceID(currentPath, conn);
//                        parentVersion = getChildVersion(conn, parentId, parentVersion, childId);
//                        parentPath = currentPath;
//                        currentPath = currentPath + RegistryConstants.PATH_SEPARATOR + parts[i];
//=======
//    private static final Log log = LogFactory.getLog(VersionedResourceDAO.class);
//
//    private DataSource dataSource;
//
//    public VersionedResourceDAO(DataSource dataSource) {
//        this.dataSource = dataSource;
//    }
//
//    /**
//     * Returns the given version of the artifact. If artifact is a collection all child paths will
//     * be added as versioned paths in the form /a/b?v=12
//     *
//     * @param path          : path of the artifact
//     * @param versionNumber : Version number
//     * @param conn          : Connection to DB
//     * @return Resource for the given version number
//     * @throws SQLException : If something went wrong
//     */
//    public ResourceImpl get(String path, long versionNumber, Connection conn)
//            throws SQLException, IOException {
//
//        ResourceImpl resource = null;
//
//        ResultSet result;
//
//        // get the resource data from the resource table
//
//        String sql = "SELECT * FROM ARTIFACTS A WHERE A.PATH=?";
//        PreparedStatement statement = conn.prepareStatement(sql);
//        statement.setString(1, path);
//
//        result = statement.executeQuery();
//
//        if (result.next()) {
//            resource = result.getInt(DatabaseConstants.DIRECTORY_FIELD) == 1 ?
//                    new CollectionImpl() : new ResourceImpl();
//
//            resource.setId(result.getLong(DatabaseConstants.AID_FIELD));
//            resource.setPath(path + ";version=" + versionNumber);
//            resource.setParentPath(getParentPath(resource.getId(), versionNumber, conn));
//            resource.setMediaType(result.getString(DatabaseConstants.MEDIA_TYPE_FIELD));
//            resource.setState(result.getInt(DatabaseConstants.STATE_FIELD));
//            resource.setAuthorUserName(result.getString(DatabaseConstants.AUTHOR_FIELD));
//            resource.setCreatedTime(result.getTimestamp(DatabaseConstants.CREATED_TIME_FIELD));
//            resource.setDescription(result.getString(DatabaseConstants.DESCRIPTION_FIELD));
//        }
//
//        if (resource == null) {
//            return null;
//        }
//
//        String sqlVersionedFields = "SELECT * FROM VERSIONS WHERE AID=? AND VN=?";
//        PreparedStatement versionQuery = conn.prepareStatement(sqlVersionedFields);
//        versionQuery.setLong(1, resource.getId());
//        versionQuery.setLong(2, versionNumber);
//
//        ResultSet versionResults = versionQuery.executeQuery();
//
//        if (versionResults.next()) {
//            resource.setVersionNumber(
//                    versionResults.getLong(DatabaseConstants.VERSION_NUMBER_FIELD));
//            resource.setLastUpdaterUserName(
//                    versionResults.getString(DatabaseConstants.VERSION_AUTHOR_FIELD));
//            resource.setLastModified(
//                    versionResults.getTimestamp(DatabaseConstants.VERSION_UPDATED_TIME));
//
//            // set the datasource to fetch the content.
//            resource.setDataSource(dataSource);
//
//            //resource.setContentStream(getDisconnectedStream(
//            //        versionResults.getBinaryStream(DatabaseConstants.VERSION_CONTENT_FIELD)));
//        }
//
//        // get resource children
//
//        if (resource.isDirectory()) {
//            String[] children = getChildPaths(resource.getId(), versionNumber, conn);
//            resource.setContent(children);
//        }
//
//
//        // get resource properties
//        return getResourceWithProperties(conn, resource);
//    }
//
//    /////////////////////////////////////////////////////////////
//    //////              Association      ////////////////////////
//    /////////////////////////////////////////////////////////////
//
//    public void addAssociation(long sourceID ,
//                               long associationID ,
//                               String associationType ,
//                               Connection con) throws SQLException {
//        String propSQL = "INSERT INTO ASSOCIATION (RID1, RID2, ASSOCIATION_TYPE) VALUES (?,?,?)";
//        PreparedStatement statement = con.prepareStatement(propSQL);
//        statement.setLong(1, sourceID);
//        statement.setLong(2,associationID);
//        statement.setString(3,associationType);
//        statement.executeUpdate();
//    }
//
//    public void removeAssociation(long sourceID ,
//                               long associationID ,
//                               String associationType ,
//                               Connection con) throws SQLException {
//        String propSQL = "DELETE FROM ASSOCIATION WHERE RID1=? AND RID2=? AND ASSOCIATION_TYPE=?";
//        PreparedStatement statement = con.prepareStatement(propSQL);
//        statement.setLong(1, sourceID);
//        statement.setLong(2,associationID);
//        statement.setString(3,associationType);
//        statement.executeUpdate();
//    }
//
//
//
//    public Association[] getAllAssociations(String resourcePath, Connection con) throws SQLException{
//        long resourceID = getResourceID(resourcePath , con);
//        String propSQL = "SELECT RID2 , ASSOCIATION_TYPE FROM ASSOCIATION WHERE RID1=?";
//        PreparedStatement statement = con.prepareStatement(propSQL);
//        statement.setLong(1,resourceID);
//        ResultSet result = statement.executeQuery();
//        ArrayList arrayList = new ArrayList();
//        while(result.next()) {
//            Association association = new Association();
//            association.setSourcePath(resourcePath);
//            long destinationID = result.getLong("RID2");
//            association.setDestinationPath(getResourcePath(destinationID ,con));
//            association.setAssociationType(result.getString("ASSOCIATION_TYPE"));
//            arrayList.add(association);
//        }
//        Association associations [] = new Association[arrayList.size()];
//        for (int i = 0; i < arrayList.size(); i++) {
//            associations[i] = (Association) arrayList.get(i);
//        }
//        return associations;
//    }
//
//     public Association[] getAllAssociationsForType(String resourcePath ,
//                                                    String associationType,
//                                                    Connection con) throws SQLException{
//        long resourceID = getResourceID(resourcePath , con);
//        String propSQL = "SELECT RID2 , ASSOCIATION_TYPE FROM ASSOCIATION WHERE RID1=? AND ASSOCIATION_TYPE=?";
//        PreparedStatement statement = con.prepareStatement(propSQL);
//        statement.setLong(1,resourceID);
//        statement.setString(2,associationType);
//        ResultSet result = statement.executeQuery();
//        ArrayList arrayList = new ArrayList();
//        while(result.next()) {
//            Association association = new Association();
//            association.setSourcePath(resourcePath);
//            long destinationID = result.getLong("RID2");
//            association.setDestinationPath(getResourcePath(destinationID ,con));
//            association.setAssociationType(associationType);
//            arrayList.add(association);
//        }
//        Association associations [] = new Association[arrayList.size()];
//        for (int i = 0; i < arrayList.size(); i++) {
//            associations[i] = (Association) arrayList.get(i);
//        }
//        return associations;
//    }
//
//
//
//
//
//
//
//    public ResourceImpl getResourceByID(
//            long artifactID, long versionNumber, Connection conn)
//            throws SQLException, IOException {
//
//        ResourceImpl resource = null;
//
//        ResultSet result;
//
//        // get the resource data from the resource table
//
//        String sql = "SELECT * FROM ARTIFACTS A WHERE A.AID=?";
//        PreparedStatement statement = conn.prepareStatement(sql);
//        statement.setLong(1, artifactID);
//
//        result = statement.executeQuery();
//
//        if (result.next()) {
//            final boolean isDirectory = result.getInt(DatabaseConstants.DIRECTORY_FIELD) == 1;
//            resource = isDirectory ? new CollectionImpl() : new ResourceImpl();
//
//            resource.setId(result.getLong(DatabaseConstants.AID_FIELD));
//            resource.setPath(result.getString(DatabaseConstants.PATH_FIELD));
//            resource.setMediaType(result.getString(DatabaseConstants.MEDIA_TYPE_FIELD));
//            resource.setState(result.getInt(DatabaseConstants.STATE_FIELD));
//            resource.setAuthorUserName(result.getString(DatabaseConstants.AUTHOR_FIELD));
//            resource.setCreatedTime(result.getTimestamp(DatabaseConstants.CREATED_TIME_FIELD));
//            resource.setDescription(result.getString(DatabaseConstants.DESCRIPTION_FIELD));
//        }
//
//        if (resource == null) {
//            return null;
//        }
//
////        boolean latestVerions = false;
//        if (versionNumber == -1) {
////            latestVerions = true;
//            versionNumber = getLatestVersionNumber(artifactID, conn);
//        }
//        String sqlVersionedFields = "SELECT * FROM VERSIONS WHERE AID=? AND VN=?";
//        PreparedStatement versionQuery = conn.prepareStatement(sqlVersionedFields);
//        versionQuery.setLong(1, resource.getId());
//        versionQuery.setLong(2, versionNumber);
//
//        ResultSet versionResults = versionQuery.executeQuery();
//
//        if (versionResults.next()) {
//            resource.setVersionNumber(
//                    versionResults.getLong(DatabaseConstants.VERSION_NUMBER_FIELD));
//            resource.setLastUpdaterUserName(
//                    versionResults.getString(DatabaseConstants.VERSION_AUTHOR_FIELD));
//            resource.setLastModified(
//                    versionResults.getTimestamp(DatabaseConstants.VERSION_UPDATED_TIME));
//
//            // set the datasource to fetch the content.
//            resource.setDataSource(dataSource);
//
//            //resource.setContentStream(getDisconnectedStream(
//            //        versionResults.getBinaryStream(DatabaseConstants.VERSION_CONTENT_FIELD)));
//        }
//
//        // get resource children
//
//        if (resource.isDirectory()) {
//
//            String[] children = getChildPaths(resource.getId(), versionNumber, conn);
//            resource.setContent(children);
//        }
//
//        // get resource properties
//        return getResourceWithProperties(conn, resource);
//    }
//
//    public InputStream getResourceContentStream(
//            long resourceID, long versionNumber, Connection conn)
//            throws SQLException, IOException {
//
//        if (versionNumber == -1) {
//            versionNumber = getLatestVersionNumber(resourceID, conn);
//        }
//
//        String sqlVersionedFields = "SELECT * FROM VERSIONS WHERE AID=? AND VN=?";
//        PreparedStatement versionQuery = conn.prepareStatement(sqlVersionedFields);
//        versionQuery.setLong(1, resourceID);
//        versionQuery.setLong(2, versionNumber);
//
//        ResultSet versionResults = versionQuery.executeQuery();
//
//        InputStream contentStream = null;
//        if (versionResults.next()) {
//            contentStream = getDisconnectedStream(
//                    versionResults.getBinaryStream(DatabaseConstants.VERSION_CONTENT_FIELD));
//        }
//
//        return contentStream;
//    }
//
//    private ResourceImpl getResourceWithProperties(Connection conn, ResourceImpl resource)
//            throws SQLException {
//        String propSQL = "SELECT P.PKEY, P.PVALUE FROM PROPERTIES P WHERE P.AID=?";
//        PreparedStatement s3 = conn.prepareStatement(propSQL);
//        s3.setLong(1, resource.getId());
//        ResultSet propResults = s3.executeQuery();
//
//        //Properties props = new Properties();
//        while (propResults.next()) {
//            String key = propResults.getString(DatabaseConstants.PROPERTY_KEY_FIELD);
//            String value = propResults.getString(DatabaseConstants.PROPERTY_VALUE_FIELD);
//            resource.addProperty(key, value);
//            //props.put(key, value);
//        }
//        //resource.setProperties(props);
//
//        return resource;
//    }
//
//    /**
//     * Returns the latest (current) version of an artifact. If artifact is a collection, all child
//     * paths will be added as latest paths in the form /a/b
//     *
//     * @param path : path of the artifact
//     * @param conn :Connection to DB
//     * @return : Result artifact
//     * @throws SQLException : if something went wrong
//     */
//    public ResourceImpl getLatestVersion(String path, Connection conn)
//            throws RegistryException, SQLException, IOException {
//        /*
//        * when someone give path like "root/wso2/wsas/r1" , then need to figure out the latest
//        * version of the root and from the need to figure out the version of wso2 and so so
//        * so when list outing the nodes need to give them correctly.
//        * */
//
//        ResourceImpl resource;
//
//        ResultSet result;
//
//        // get the resource data from the resource table
//
//        String sql = "SELECT * FROM ARTIFACTS A WHERE A.PATH=?";
//        PreparedStatement statement = conn.prepareStatement(sql);
//        statement.setString(1, path);
//
//        result = statement.executeQuery();
//
//        if (!result.next())
//            return null;
//
//        final boolean isDirectory = result.getInt(DatabaseConstants.DIRECTORY_FIELD) == 1;
//        resource = isDirectory ? new CollectionImpl() : new ResourceImpl();
//
//        resource.setId(result.getLong(DatabaseConstants.AID_FIELD));
//        resource.setPath(result.getString(DatabaseConstants.PATH_FIELD));
//        resource.setParentPath(getParentPath(resource.getPath()));
//        resource.setMediaType(result.getString(DatabaseConstants.MEDIA_TYPE_FIELD));
//        resource.setState(result.getInt(DatabaseConstants.STATE_FIELD));
//        resource.setAuthorUserName(result.getString(DatabaseConstants.AUTHOR_FIELD));
//        resource.setCreatedTime(result.getTimestamp(DatabaseConstants.CREATED_TIME_FIELD));
//        resource.setDescription(result.getString(DatabaseConstants.DESCRIPTION_FIELD));
//
////        long latestVersionNumber = getLatestVersionNumber(resource.getId(), conn);
//        long latestVersionNumber = getCurrentVersionNumber(resource.getPath(), conn);
//
//        String sqlVersionedFields = "SELECT * FROM VERSIONS WHERE AID=? AND VN=?";
//        PreparedStatement versionQuery = conn.prepareStatement(sqlVersionedFields);
//        versionQuery.setLong(1, resource.getId());
//        versionQuery.setLong(2, latestVersionNumber);
//
//        ResultSet versionResults = versionQuery.executeQuery();
//
//        if (versionResults.next()) {
//            resource.setVersionNumber(
//                    versionResults.getLong(DatabaseConstants.VERSION_NUMBER_FIELD));
//            resource.setLastUpdaterUserName(
//                    versionResults.getString(DatabaseConstants.VERSION_AUTHOR_FIELD));
//            resource.setLastModified(
//                    versionResults.getTimestamp(DatabaseConstants.VERSION_UPDATED_TIME));
//
//            // set the datasource to fetch the content.
//            resource.setDataSource(dataSource);
//
//            //if (!isDirectory) {
//            //    resource.setContentStream(getDisconnectedStream(
//            //            versionResults.getBinaryStream(DatabaseConstants.VERSION_CONTENT_FIELD)));
//            //}
//        }
//
//        // get resource children
//        if (resource.isDirectory()) {
//            String[] children = getLatestChildPaths(resource.getId(),
//                    getCurrentVersionNumber(path, conn), conn);
//            resource.setContent(children);
//        }
//        // get resource properties
//        return getResourceWithProperties(conn, resource);
//    }
//
//    /**
//     * To get the current version for a give resource , current version may not be the latest
//     * version in all the cases. If someone restore a resource then the child nodes will remain same
//     * But the parent version will be changed. In that case the parent [foo/bar] version will be the
//     * latest version but the child node version [foo/bar/v1] will be an old version . So when some
//     * one ask for the resource value foo/bar/v1 then we need to calculate them correctly and give
//     * that.
//     *
//     * @param path : Resource ID
//     * @param conn : Connection to DB
//     * @return : verion number of the resource user requested
//     */
//    public long getCurrentVersionNumber(String path, Connection conn) throws RegistryException {
//        if (path != null) {
//            try {
//                String[] parts = path.split(RegistryConstants.PATH_SEPARATOR);
//                if (parts.length > 1) {
//                    String currentPath = RegistryConstants.ROOT_PATH + parts[1];
//                    String parentPath = RegistryConstants.ROOT_PATH;
//                    long parentVersion = getLatestVersionNumber(
//                            getResourceID(RegistryConstants.ROOT_PATH, conn), conn);
//                    long childId = 1;
//                    for (int i = 2; i < parts.length; i++) {
//                        if (!resourceActive(parentPath, conn)) {
//                            throw new RegistryException("Resource is not active");
//                        }
//                        long parentId = getResourceID(parentPath, conn);
//                        childId = getResourceID(currentPath, conn);
//                        parentVersion = getChildVersion(conn, parentId, parentVersion, childId);
//                        parentPath = currentPath;
//                        currentPath = currentPath + RegistryConstants.PATH_SEPARATOR + parts[i];
//                    }
//                    if (parts.length == 2) {
//                        childId = getResourceID(parentPath, conn);
//
//                    }
//                    long id = getResourceID(currentPath, conn);
//                    return getChildVersion(conn, childId, parentVersion, id);
//
//                } else {
//                    return getLatestVersionNumber(getResourceID(path, conn), conn);
//                }
//                int index = path.lastIndexOf(RegistryConstants.PATH_SEPARATOR);
//                if (index > 0) {
//                    String parentPath = path.substring(0, index);
//                    long parentId = getResourceID(parentPath, conn);
//                    long latestVersion = getLatestVersionNumber(parentId, conn);
//                    long childID = getResourceID(path, conn);
//                    String SQL = "SELECT DVN FROM DEPENDENCY WHERE AID=? AND VN=? AND DAID=?";
//                    PreparedStatement s = conn.prepareStatement(SQL);
//                    s.setLong(1, parentId);
//                    s.setLong(2, latestVersion);
//                    s.setLong(3, childID);
//                    ResultSet result = s.executeQuery();
//                    if (result.next()) {
//                        return result.getLong(1);
//>>>>>>> .r15909
//                    }
//                    if (parts.length == 2) {
//                        childId = getResourceID(parentPath, conn);
//
//                    }
//                    long id = getResourceID(currentPath, conn);
//                    return getChildVersion(conn, childId, parentVersion, id);
//
//                } else {
//                    return getLatestVersionNumber(getResourceID(path, conn), conn);
//                }
//<<<<<<< .mine
////                int index = path.lastIndexOf(RegistryConstants.PATH_SEPARATOR);
////                if (index > 0) {
////                    String parentPath = path.substring(0, index);
////                    long parentId = getResourceID(parentPath, conn);
////                    long latestVersion = getLatestVersionNumber(parentId, conn);
////                    long childID = getResourceID(path, conn);
////                    String SQL = "SELECT DVN FROM DEPENDENCY WHERE AID=? AND VN=? AND DAID=?";
////                    PreparedStatement s = conn.prepareStatement(SQL);
////                    s.setLong(1, parentId);
////                    s.setLong(2, latestVersion);
////                    s.setLong(3, childID);
////                    ResultSet result = s.executeQuery();
////                    if (result.next()) {
////                        return result.getLong(1);
////                    }
////                } else {
////                    return getLatestVersionNumber(getResourceID(path, conn), conn);
////                }
//            } catch (SQLException e) {
//                log.info("Something went wrong while calculating the current " +
//                        "version for the path : " + path + " and the error us " + e);
//                return -1;
//            }
//        }
//        return -1;
//    }
//
//    private long getChildVersion(Connection conn,
//                                 long parentId,
//                                 long parentVersion,
//                                 long childId) throws SQLException {
//        String SQL = "SELECT DVN FROM DEPENDENCY WHERE AID=? AND VN=? AND DAID=?";
//        PreparedStatement selectps = conn.prepareStatement(SQL);
//        selectps.setLong(1, parentId);
//        selectps.setLong(2, parentVersion);
//        selectps.setLong(3, childId);
//        ResultSet childResult = selectps.executeQuery();
//        if (childResult.next()) {
//            return childResult.getLong("DVN");
//        }
//        return -1;
//    }
//
//    public String[] getChildPaths(long artifcatID, long versionNumber,
//                                  Connection connection) throws SQLException {
//
//        String selectSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//        PreparedStatement s = connection.prepareStatement(selectSql);
//        s.setLong(1, artifcatID);
//        s.setLong(2, versionNumber);
//        ResultSet result = s.executeQuery();
//
//        ArrayList dependencyPathList = new ArrayList();
//
//        //to see whether the patent node is there in the table , if not need to add that
//        while (result.next()) {
//            long daid = result.getLong("DAID");
//            long childVersion = result.getLong("DVN");
//            String SQL = "SELECT PATH FROM ARTIFACTS WHERE AID=?";
//            PreparedStatement ps = connection.prepareStatement(SQL);
//            ps.setLong(1, daid);
//            ResultSet pathResult = ps.executeQuery();
//            if (pathResult.next()) {
//                String path = pathResult.getString("PATH") + "?v=" + childVersion;
//                dependencyPathList.add(path);
//            }
//        }
//        return (String[])(dependencyPathList.toArray(new String[dependencyPathList.size()]));
//    }
//
//    public String getParentPath(long resourceID, long versionNumber,
//                                Connection connection) throws SQLException {
//
//        if (versionNumber == -1) {
//            versionNumber = getLatestVersionNumber(resourceID, connection);
//        }
//        if (versionNumber == -1) {
//            return null;
//        }
//        String selectSql = "SELECT AID , VN FROM DEPENDENCY WHERE DAID=? AND DVN=?";
//        PreparedStatement s = connection.prepareStatement(selectSql);
//        s.setLong(1, resourceID);
//        s.setLong(2, versionNumber);
//        ResultSet result = s.executeQuery();
//
//        String parentPath = "";
//
//        //to see whether the patent node is there in the table , if not need to add that
//        if (result.next()) {
//            long aid = result.getLong("AID");
//            long parentVersionNumber = result.getLong("VN");
//            String SQL = "SELECT PATH FROM ARTIFACTS WHERE AID=?";
//            PreparedStatement ps = connection.prepareStatement(SQL);
//            ps.setLong(1, aid);
//            ResultSet pathResult = ps.executeQuery();
//            if (pathResult.next()) {
//                String path = pathResult.getString("PATH");
//                parentPath = path + "?v=" + parentVersionNumber;
//            }
//        }
//        return parentPath;
//    }
//
//    public String[] getLatestChildPaths(long resourceID, long versionNumber,
//                                        Connection connection) throws SQLException {
//
//        String selectSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//        PreparedStatement s = connection.prepareStatement(selectSql);
//        s.setLong(1, resourceID);
//        s.setLong(2, versionNumber);
//        ResultSet result = s.executeQuery();
//
//        ArrayList dependencyPathList = new ArrayList();
//
//        //to see whether the patent node is there in the table , if not need to add that
//        while (result.next()) {
//            long daid = result.getLong("DAID");
//            String SQL = "SELECT PATH FROM ARTIFACTS WHERE AID=?";
//            PreparedStatement ps = connection.prepareStatement(SQL);
//            ps.setLong(1, daid);
//            ResultSet pathResult = ps.executeQuery();
//            if (pathResult.next()) {
//                String path = pathResult.getString("PATH");
//                dependencyPathList.add(path);
//            }
//        }
//        return (String[])(dependencyPathList.toArray(new String[dependencyPathList.size()]));
//    }
//
//    public List getChildren(long resourceID, long versionNumber,
//                            Connection connection) throws SQLException {
//
//        if (versionNumber == -1) {
//            versionNumber = getLatestVersionNumber(resourceID, connection);
//        }
//
//        String selectSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//        PreparedStatement s = connection.prepareStatement(selectSql);
//        s.setLong(1, resourceID);
//        s.setLong(2, versionNumber);
//        ResultSet result = s.executeQuery();
//
//        ArrayList childList = new ArrayList();
//
//        //to see whether the patent node is there in the table , if not need to add that
//        while (result.next()) {
//
//            long daid = result.getLong("DAID");
//            String SQL = "SELECT AID, PATH, DIRECTORY FROM ARTIFACTS WHERE AID=?";
//            PreparedStatement ps = connection.prepareStatement(SQL);
//            ps.setLong(1, daid);
//
//            ResultSet pathResult = ps.executeQuery();
//            if (pathResult.next()) {
//                final boolean isDirectory =
//                        pathResult.getInt(DatabaseConstants.DIRECTORY_FIELD) == 1;
//                ResourceImpl child = isDirectory ? new CollectionImpl() : new ResourceImpl();
//                child.setId(pathResult.getLong(DatabaseConstants.AID_FIELD));
//                child.setPath(pathResult.getString(DatabaseConstants.PATH_FIELD));
//                childList.add(child);
//            }
//        }
//        return childList;
//    }
//
//    /**
//     * Adds the given resource to the database.
//     *
//     * @param resource New resource
//     * @param conn     : Connection to Db
//     * @throws java.sql.SQLException : if something went wrong
//     */
//    public void add(ResourceImpl resource, Connection conn) throws SQLException, RegistryException {
//
//        // first add the resource data into the artifacts table
//
//        String sql =
//                "INSERT INTO ARTIFACTS (PATH, MEDIA_TYPE, DIRECTORY, STATE, CREATED_TIME, AUTHOR, " +
//                        "DESCRIPTION) VALUES (?,?,?,?,?,?,?)";
//
//        long now = System.currentTimeMillis();
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setString(1, resource.getPath());
//        s.setString(2, resource.getMediaType());
//        s.setInt(3, resource instanceof Collection ? 1 : 0);
//        s.setInt(4, RegistryConstants.ACTIVE_STATE);
//        s.setTimestamp(5, new Timestamp(now));
//        s.setString(6, resource.getAuthorUserName());
//        s.setString(7, resource.getDescription());
//
//        s.executeUpdate();
//
//
//        long newArtifactID = this.getResourceID(resource.getPath(), conn);
//
//        // now add resource properties to the properties table
//        addProperties(newArtifactID, resource.getProperties(), conn);
//    }
//
//    public void update(String path, ResourceImpl resource, Connection conn)
//=======
//            } catch (SQLException e) {
//                log.info("Something went wrong while calculating the current " +
//                        "version for the path : " + path + " and the error us " + e);
//                return -1;
//            }
//        }
//        return -1;
//    }
//
//    private long getChildVersion(Connection conn,
//                                 long parentId,
//                                 long parentVersion,
//                                 long childId) throws SQLException {
//        String SQL = "SELECT DVN FROM DEPENDENCY WHERE AID=? AND VN=? AND DAID=?";
//        PreparedStatement selectps = conn.prepareStatement(SQL);
//        selectps.setLong(1, parentId);
//        selectps.setLong(2, parentVersion);
//        selectps.setLong(3, childId);
//        ResultSet childResult = selectps.executeQuery();
//        if (childResult.next()) {
//            return childResult.getLong("DVN");
//        }
//        return -1;
//    }
//
//    public String[] getChildPaths(long artifcatID, long versionNumber,
//                                  Connection connection) throws SQLException {
//
//        String selectSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//        PreparedStatement s = connection.prepareStatement(selectSql);
//        s.setLong(1, artifcatID);
//        s.setLong(2, versionNumber);
//        ResultSet result = s.executeQuery();
//
//        ArrayList dependencyPathList = new ArrayList();
//
//        //to see whether the patent node is there in the table , if not need to add that
//        while (result.next()) {
//            long daid = result.getLong("DAID");
//            long childVersion = result.getLong("DVN");
//            String SQL = "SELECT PATH FROM ARTIFACTS WHERE AID=?";
//            PreparedStatement ps = connection.prepareStatement(SQL);
//            ps.setLong(1, daid);
//            ResultSet pathResult = ps.executeQuery();
//            if (pathResult.next()) {
//                String path = pathResult.getString("PATH") + ";version=" + childVersion;
//                dependencyPathList.add(path);
//            }
//        }
//        return (String[])(dependencyPathList.toArray(new String[dependencyPathList.size()]));
//    }
//
//    public String getParentPath(long resourceID, long versionNumber,
//                                Connection connection) throws SQLException {
//
//        if (versionNumber == -1) {
//            versionNumber = getLatestVersionNumber(resourceID, connection);
//        }
//        if (versionNumber == -1) {
//            return null;
//        }
//        String selectSql = "SELECT AID , VN FROM DEPENDENCY WHERE DAID=? AND DVN=?";
//        PreparedStatement s = connection.prepareStatement(selectSql);
//        s.setLong(1, resourceID);
//        s.setLong(2, versionNumber);
//        ResultSet result = s.executeQuery();
//
//        String parentPath = "";
//
//        //to see whether the patent node is there in the table , if not need to add that
//        if (result.next()) {
//            long aid = result.getLong("AID");
//            long parentVersionNumber = result.getLong("VN");
//            String SQL = "SELECT PATH FROM ARTIFACTS WHERE AID=?";
//            PreparedStatement ps = connection.prepareStatement(SQL);
//            ps.setLong(1, aid);
//            ResultSet pathResult = ps.executeQuery();
//            if (pathResult.next()) {
//                String path = pathResult.getString("PATH");
//                parentPath = path + ";version=" + parentVersionNumber;
//            }
//        }
//        return parentPath;
//    }
//
//    public String[] getLatestChildPaths(long resourceID, long versionNumber,
//                                        Connection connection) throws SQLException {
//
//        String selectSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//        PreparedStatement s = connection.prepareStatement(selectSql);
//        s.setLong(1, resourceID);
//        s.setLong(2, versionNumber);
//        ResultSet result = s.executeQuery();
//
//        ArrayList dependencyPathList = new ArrayList();
//
//        //to see whether the patent node is there in the table , if not need to add that
//        while (result.next()) {
//            long daid = result.getLong("DAID");
//            String SQL = "SELECT PATH FROM ARTIFACTS WHERE AID=?";
//            PreparedStatement ps = connection.prepareStatement(SQL);
//            ps.setLong(1, daid);
//            ResultSet pathResult = ps.executeQuery();
//            if (pathResult.next()) {
//                String path = pathResult.getString("PATH");
//                dependencyPathList.add(path);
//            }
//        }
//        return (String[])(dependencyPathList.toArray(new String[dependencyPathList.size()]));
//    }
//
//    public List getChildren(long resourceID, long versionNumber,
//                            Connection connection) throws SQLException {
//
//        if (versionNumber == -1) {
//            versionNumber = getLatestVersionNumber(resourceID, connection);
//        }
//
//        String selectSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//        PreparedStatement s = connection.prepareStatement(selectSql);
//        s.setLong(1, resourceID);
//        s.setLong(2, versionNumber);
//        ResultSet result = s.executeQuery();
//
//        ArrayList childList = new ArrayList();
//
//        //to see whether the patent node is there in the table , if not need to add that
//        while (result.next()) {
//
//            long daid = result.getLong("DAID");
//            String SQL = "SELECT AID, PATH, DIRECTORY FROM ARTIFACTS WHERE AID=?";
//            PreparedStatement ps = connection.prepareStatement(SQL);
//            ps.setLong(1, daid);
//
//            ResultSet pathResult = ps.executeQuery();
//            if (pathResult.next()) {
//                final boolean isDirectory =
//                        pathResult.getInt(DatabaseConstants.DIRECTORY_FIELD) == 1;
//                ResourceImpl child = isDirectory ? new CollectionImpl() : new ResourceImpl();
//                child.setId(pathResult.getLong(DatabaseConstants.AID_FIELD));
//                child.setPath(pathResult.getString(DatabaseConstants.PATH_FIELD));
//                child.setVersionNumber(result.getLong("DVN"));
//                childList.add(child);
//            }
//        }
//        return childList;
//    }
//
//    /**
//     * Adds the given resource to the database.
//     *
//     * @param resource New resource
//     * @param conn     : Connection to Db
//     * @throws java.sql.SQLException : if something went wrong
//     */
//    public void add(ResourceImpl resource, Connection conn) throws SQLException, RegistryException {
//
//        // first add the resource data into the artifacts table
//
//        String sql =
//                "INSERT INTO ARTIFACTS (PATH, MEDIA_TYPE, DIRECTORY, STATE, CREATED_TIME, AUTHOR, " +
//                        "DESCRIPTION) VALUES (?,?,?,?,?,?,?)";
//
//        long now = System.currentTimeMillis();
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setString(1, resource.getPath());
//        s.setString(2, resource.getMediaType());
//        s.setInt(3, resource instanceof Collection ? 1 : 0);
//        s.setInt(4, RegistryConstants.ACTIVE_STATE);
//        s.setTimestamp(5, new Timestamp(now));
//        s.setString(6, resource.getAuthorUserName());
//        s.setString(7, resource.getDescription());
//
//        s.executeUpdate();
//
//
//        long newArtifactID = this.getResourceID(resource.getPath(), conn);
//
//        // now add resource properties to the properties table
//        addProperties(newArtifactID, resource.getProperties(), conn);
//    }
//
//    public void update(String path, ResourceImpl resource, Connection conn)
//            throws SQLException, RegistryException {
//
//        // first update the artifacts table
//
//        String sql =
//                "UPDATE ARTIFACTS SET MEDIA_TYPE=?, DIRECTORY=?, STATE=?, AUTHOR=?, DESCRIPTION=? WHERE PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//
//        s.setString(1, resource.getMediaType());
//        s.setInt(2, resource.isDirectory() ? 1 : 0);
//        s.setInt(3, resource.getState());
//        s.setString(4, resource.getAuthorUserName());
//        s.setString(5, resource.getDescription());
//
//        s.setString(6, path);
//
//        s.executeUpdate();
//
//        // remove existing properties for the updated artifact
//        removeProperties(resource.getId(), conn);
//
//        // now add the updated properties to the properties table
//        addProperties(resource.getId(), resource.getProperties(), conn);
//    }
//
//    public void markDeleted(String path, Connection conn) throws SQLException {
//
//        String sql = "UPDATE ARTIFACTS SET STATE=? WHERE PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setInt(1, RegistryConstants.DELETED_STATE);
//        s.setString(2, path);
//        s.executeUpdate();
//    }
//
//    public void markActivated(long id, Connection conn) throws SQLException {
//
//        String sql = "UPDATE ARTIFACTS SET STATE=? WHERE AID=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setInt(1, RegistryConstants.ACTIVE_STATE);
//        s.setLong(2, id);
//        s.executeUpdate();
//    }
//
//
//    public void addProperties(long resourceID, Properties props, Connection conn)
//            throws SQLException {
//
//        String propSQL = "INSERT INTO PROPERTIES (AID, PKEY, PVALUE) VALUES (?,?,?)";
//        PreparedStatement s2 = conn.prepareStatement(propSQL);
//
//        if (props != null) {
//
//            Iterator i = props.keySet().iterator();
//            while (i.hasNext()) {
//                String key = (String)i.next();
//
//                List propValues = (List) props.get(key);
//                if (propValues != null) {
//                    Iterator<String> iValues = propValues.iterator();
//                    while (iValues.hasNext()) {
//                        String value = iValues.next();
//
//                        s2.setLong(1, resourceID);
//                        s2.setString(2, key);
//                        s2.setString(3, value);
//
//                        s2.executeUpdate();
//                        s2.clearParameters();
//                    }
//                }
//
//                //String value = (String)props.get(key);
//                //
//                //s2.setLong(1, resourceID);
//                //s2.setString(2, key);
//                //s2.setString(3, value);
//                //
//                //s2.executeUpdate();
//                //s2.clearParameters();
//            }
//        }
//    }
//
//    public void removeProperties(long resourceID, Connection conn) throws SQLException {
//
//        String removePropsSQL = "DELETE FROM PROPERTIES WHERE AID=?";
//        PreparedStatement s2 = conn.prepareStatement(removePropsSQL);
//        s2.setLong(1, resourceID);
//        s2.executeUpdate();
//    }
//
//    public boolean resourceExist(String path, Connection conn) throws SQLException {
//
//        String sql = "SELECT COUNT(A.AID) FROM ARTIFACTS A WHERE A.PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setString(1, path);
//
//        ResultSet result = s.executeQuery();
//        long count = 0;
//        if (result.next()) {
//            count = result.getLong(1);
//        }
//
//        return count == 1;
//    }
//
//    public boolean resourceActive(String path, Connection conn) throws SQLException {
//
//        String sql = "SELECT STATE FROM ARTIFACTS A WHERE A.PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setString(1, path);
//
//        ResultSet result = s.executeQuery();
//        long count = 0;
//        if (result.next()) {
//            count = result.getLong(1);
//        }
//        return RegistryConstants.ACTIVE_STATE == count;
//    }
//
//    public long getResourceID(String path, Connection conn) throws SQLException {
//
//        String sql = "SELECT A.AID FROM ARTIFACTS A WHERE A.PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setString(1, path);
//
//        ResultSet result = s.executeQuery();
//        if (result.next()) {
//            return result.getLong(DatabaseConstants.AID_FIELD);
//        }
//
//        return -1;
//    }
//
//    public String getResourcePath(long id, Connection conn) throws SQLException {
//
//        String sql = "SELECT A.PATH FROM ARTIFACTS A WHERE A.AID=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setLong(1, id);
//
//        ResultSet result = s.executeQuery();
//        if (result.next()) {
//            return result.getString(DatabaseConstants.PATH_FIELD);
//        }
//        return null;
//    }
//
//    /**
//     * This method will copy a resource from oldpath to newpath , the internal implementation is
//     * such that copy all the resources from oldpath to new path including tags , comments and ratings.
//     *
//     * @param oldPath : Current path of the resource
//     * @param newPath : Where to move the resource
//     * @param userId  : current user
//     * @param realm   : Realm
//     * @throws org.wso2.registry.RegistryException
//     *          : If something went wrong
//     */
//    public void renameWithoutDelete(String oldPath,
//                               String newPath,
//                               String userId,
//                               UserRealm realm,
//                               Registry registry) throws SQLException, RegistryException, IOException {
//        Connection conn = dataSource.getConnection();
//        ResourceImpl resource = getLatestVersion(oldPath, conn);
//        String resourcePath = resource.getPath();
//        //to see whether the patent node is there in the table , if not need to add that
//        createParentCollections(newPath, conn, userId, realm);
//        // if the resource is a directory then need to populate the dependecy table with
//        // the new resource id , while keeping the old one as it is
//        if (resource.isDirectory()) {
//            copyResource(oldPath, newPath, registry, true, conn);
//        } else {
//            // Then its just need to add the resource and no need to update any of the
//            // dependecy tables
//            resource.setPath(newPath);
//            if (resource.getAuthorUserName() == null) {
//                resource.setAuthorUserName(userId);
//            }
//            InputStream in = resource.getContentStream();
//            resource.setLastUpdaterUserName(userId);
//            add(resource, conn);
//            AuthorizationUtil.setDefaultAuthorizations(realm, newPath, userId);
//            long newResourceID = getResourceID(newPath, conn);
//            resource.setId(newResourceID);
//
//            resource.setContentStream(in);
//            addResourceVersion(resource, conn);
//            resource.setPath(resourcePath);
//
//            long fromResourceId = getResourceID(oldPath, conn);
//            //copying the comments
//            CommentsDAO commentsDAO = new CommentsDAO();
//            commentsDAO.copyComments(oldPath, newResourceID, conn);
//            //coping the tags
//            TagsDAO tags = new TagsDAO(dataSource);
//            tags.copyTags(fromResourceId, newResourceID, conn);
//
//            // copy ratings
//            RatingsDAO ratingsDAO = new RatingsDAO();
//            ratingsDAO.copyRatings(fromResourceId, newResourceID, conn);
//
//        }
//    }
//    /**
//     * This method will move a resource from oldpath to newpath , the internal implementation is
//     * such that frit the release will be deleted from oldPath parent and will be added to the
//     * newptah so if the oldpath is "foo/bar/r1" then the r1 will be removed from foo/bar. However
//     * later we can restore and get everything working fine
//     *
//     * @param oldPath : Current path of the resource
//     * @param newPath : Where to move the resource
//     * @param conn    : Connection to DB
//     * @param userId  : current user
//     * @param realm   : Realm
//     * @throws org.wso2.registry.RegistryException
//     *          : If something went wrong
//     */
//    public void renameResource(String oldPath,
//                               String newPath,
//                               Connection conn,
//                               String userId,
//                               UserRealm realm,
//                               Registry registry)
//            throws SQLException, IOException, RegistryException {
//
//        ResourceImpl resource = getLatestVersion(oldPath, conn);
//
//        // calling the getContentStream loads the input stream to the resource. so we can
//        // access it even after changing the original resource.
//        resource.setContentStream(resource.getContentStream());
//
//        String resourcePath = resource.getPath();
//        long resourceID = resource.getId();
//        //to see whether the patent node is there in the table , if not need to add that
//        createParentCollections(newPath, conn, userId, realm);
//        // if the resource is a directory then need to populate the dependecy table with
//        // the new resource id , while keeping the old one as it is
//        if (resource.isDirectory()) {
//            copyResource(oldPath, newPath, registry, true, conn);
//        } else {
//            // Then its just need to add the resource and no need to update any of the
//            // dependecy tables
//            resource.setPath(newPath);
//            if (resource.getAuthorUserName() == null) {
//                resource.setAuthorUserName(userId);
//            }
//            resource.setLastUpdaterUserName(userId);
//            markDeleted(resourcePath, conn);
//            deleteResource(resource, conn);
//            add(resource, conn);
//            AuthorizationUtil.setDefaultAuthorizations(realm, newPath, userId);
//            long newResourceID = getResourceID(newPath, conn);
//            resource.setId(newResourceID);
//            addResourceVersion(resource, conn);
//            resource.setPath(resourcePath);
//            resource.setId(resourceID);
//
//            long fromResourceId = getResourceID(oldPath, conn);
//            //copying the comments
//            CommentsDAO commentsDAO = new CommentsDAO();
//            commentsDAO.copyComments(oldPath, resourceID, conn);
//            //coping the tags
//            TagsDAO tags = new TagsDAO(dataSource);
//            tags.copyTags(fromResourceId, resourceID, conn);
//
//            // copy ratings// set the datasource to fetch the content.
//            resource.setDataSource(dataSource);
//            RatingsDAO ratingsDAO = new RatingsDAO();
//            ratingsDAO.copyRatings(fromResourceId, resourceID, conn);
//
//        }
//        //prepareToDelete(resource.getId(), conn);
//        //resourceDAO.delete(resource.getResourcePath(), conn);
//    }
//
//
//    /**
//     * This method use to copy a resource from given location to some other location When we do so
//     * all the resource properties , tags  , comments and everything will be copy into new location
//     *
//     * @param fromPath   : Which collection to copy
//     * @param toPath     : Where to copy
//     * @param registry   : Instance of a registry
//     * @param useOrginal : to indicate whether firt time call or not
//     * @throws RegistryException
//     */
//    private void copyResource(String fromPath,
//                              String toPath,
//                              Registry registry,
//                              boolean useOrginal,
//                              Connection conn) throws RegistryException {
//        ResourceImpl resource = (ResourceImpl)registry.get(fromPath);
//        if (resource != null) {
//
//            String resourcePath = resource.getPath();
//            int verionIndex = resourcePath.indexOf("?");
//            if (verionIndex > 0) {
//                resourcePath = resourcePath.substring(0, verionIndex);
//            }
//            int slashIndex = resourcePath.lastIndexOf("/");
//            //getting only the last part of the resource path
//            resourcePath = resourcePath.substring(slashIndex, resourcePath.length());
//
//            String currentPath;
//            if (!useOrginal) {
//                currentPath = toPath + resourcePath;
//            } else {
//                currentPath = toPath;
//            }
//
//            if (resource.isDirectory()) {
//                String childNodes[] = (String[])resource.getContent();
//                for (String childNode : childNodes) {
//                    copyResource(childNode, currentPath, registry, false, conn);
//                }
//            }
//            InputStream in = resource.getContentStream();
//            resource.setPath(currentPath);
//            resource.setContentStream(in);
//            registry.put(currentPath, resource);
//            try {
//                long resourceId = getResourceID(currentPath, conn);
//                long fromResourceId = getResourceID(fromPath, conn);
//                //copying the comments
//                CommentsDAO commentsDAO = new CommentsDAO();
//                commentsDAO.copyComments(fromPath, resourceId, conn);
//                //coping the tags
//                TagsDAO tags = new TagsDAO(dataSource);
//                tags.copyTags(fromResourceId, resourceId, conn);
//
//                // copy ratings
//                RatingsDAO ratingsDAO = new RatingsDAO();
//                ratingsDAO.copyRatings(fromResourceId, resourceId, conn);
//            } catch (SQLException e) {
//                log.info(e);
//            }
//        } else {
//            log.info("No resource found for : " + fromPath);
//        }
//    }
//
//    public long addResourceVersion(ResourceImpl resource, Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        if (resource.getLastModified() == null) {
//            resource.setLastModified(new java.util.Date());
//        }
//
//        long versionNumber = insertToVersionTable(resource, connection);
//
//        //updating max version table
//        updateDependency(resource, versionNumber, false, connection);
//        return versionNumber;
//    }
//
//    private long insertToVersionTable(ResourceImpl resource, Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        String sql =
//                "INSERT INTO VERSIONS (AID, VN, CONTENT, AUTHOR, UPDATED_TIME) VALUES (?,?,?,?,?)";
//        PreparedStatement statement = connection.prepareStatement(sql);
//        statement.setLong(1, resource.getId());
//
//        // Need to get the old version and increment that
//        // Select VID from latest table ,
//        // if it is there then find from that  , if it is not there then we need ti start from 0
//        long versionNumber = getLatestVersionNumber(resource.getId(), connection);
//        if (versionNumber == -1) {
//            versionNumber = 1;
//        } else {
//            //incrementing the version number
//            versionNumber = versionNumber + 1;
//        }
//        statement.setLong(2, versionNumber);
//
//        InputStream contentStream = resource.getContentStream();
//        if (contentStream != null) {
//
//            File tempFile = File.createTempFile("reg", "tmp");
//            OutputStream fileStream = new BufferedOutputStream(new FileOutputStream(tempFile));
//            InputStream bufferedIn = new BufferedInputStream(contentStream);
//
//            byte[] dataChunk = new byte[1024];
//            int byteCount;
//            while ((byteCount = bufferedIn.read(dataChunk)) != -1) {
//                fileStream.write(dataChunk, 0, byteCount);
//            }
//            fileStream.flush();
//            bufferedIn.close();
//            fileStream.close();
//
//            // there is no use of content stream after it is closed. so we can set it to null to
//            // avoid using it again.
//            resource.setContentStream(null);
//
//            InputStream tempFileStream = new BufferedInputStream(new FileInputStream(tempFile));
//            long contentLength = tempFile.length();
//
//            statement.setBinaryStream(3, tempFileStream, (int)contentLength);
//
//        } else {
//            statement.setBytes(3, convertToBytes(resource.getContent()));
//        }
//
//        //byte[] bytes = convertToBytes(content);
//
//        String userName = resource.getLastUpdaterUserName();
//        if (userName == null) {
//            userName = User.getCurrentUser();
//        }
//        statement.setString(4, userName);
//        statement.setTimestamp(5, new Timestamp(System.currentTimeMillis()));
//        statement.executeUpdate();
//
//        return versionNumber;
//    }
//
//    public static byte[] convertToBytes(Object object) {
//        if (object instanceof byte[])
//            return (byte[])object;
//        if (object instanceof String)
//            return ((String)object).getBytes();
//        if (object instanceof DataHandler) {
//            try {
//                object = ((DataHandler)object).getInputStream();
//            } catch (IOException e) {
//                return null;
//            }
//        }
//        if (object instanceof InputStream) {
//            // TODO - fix this to really work.
//            InputStream is = (InputStream)object;
//            byte[] bytes;
//            try {
//                int avail = is.available();
//                bytes = new byte[avail];
//                is.read(bytes);
//            } catch (IOException e) {
//                return null;
//            }
//            return bytes;
//        }
//
//        return null;
//    }
//
//    private void updateDependency(ResourceImpl resource,
//                                  long versionNumber,
//                                  boolean delete, Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        // updating dependency table , so that we can rollbackTransaction to a particular version
//        // updating for the current resource
//        long parentNextVersionNumber =
//                updateDependencyTable(resource, versionNumber, delete, connection);
//
//        // a/b/c/r1.wsdl
//        // Next a/b/c
//        // Next a/b
//        // Next a
//        if (parentNextVersionNumber != -1) {
//
//            // updating its parent
//            String path = resource.getPath();
//            while (path != null && path.indexOf("/") > -1) {
//
//                int lastIndex = path.lastIndexOf("/");
//                String parentPath = path.substring(0, lastIndex);
//                ResourceImpl parentArtifact = getLatestVersion(parentPath, connection);
//
//                if (parentArtifact != null) {
//                    path = parentArtifact.getPath();
//                    parentArtifact.setLastUpdaterUserName(resource.getLastUpdaterUserName());
//                    parentNextVersionNumber = updateDependencyTable(
//                            parentArtifact, parentNextVersionNumber, false, connection);
//
//                    if (parentNextVersionNumber == -1) {
//                        break;
//                    }
//                } else {
//                    break;
//                }
//            }
//        }
//    }
//
//    /**
//     * @param resource      : Artifact we need to update itself and its immediate parent
//     * @param versionNumber : Version number of the artifact
//     * @param delete        : delete or adding
//     * @param connection    : DB connection
//     * @return : Will return the resource version of the parent resource
//     * @throws SQLException : if something went wrong
//     */
//    private long updateDependencyTable(ResourceImpl resource,
//                                       long versionNumber,
//                                       boolean delete, Connection connection)
//            throws SQLException, IOException, RegistryException {
//        /**
//         *        D0
//         *    D1      D2
//         *  D3  R1    R2
//         *
//         *  First fine D1 V0
//         */
//        // Checking whether the path is null or top most directory
//        // Checking whether resource is root node or not
//
//        String path = resource.getPath();
//
//        // Checking whether the path is null or top most directory
//        // if (path != null && path.indexOf("/") > -1) {
//        if (path != null && !path.equals(RegistryConstants.ROOT_PATH)) {
//
//            int lastIndex = path.lastIndexOf("/");
//            String parentPath = RegistryConstants.ROOT_PATH;
//            if (lastIndex != 0) {
//                parentPath = path.substring(0, lastIndex);
//            }
//
//            if ("".equals(parentPath)) {
//                //TODO : Need to think the logic here
//
//            } else {
//
//                long parentId = getResourceID(parentPath, connection);
//
//                if (resource.getLastModified() == null) {
//                    resource.setLastModified(new java.util.Date());
//                }
//
//                // Need to get the parent's parent and update the and update the
//
//                long artifactVersionNumber = getCurrentVersionNumber(parentPath, connection);
////                long artifactVersionNumber = getLatestVersionNumber(parentId, connection);
//
//                long nextVersionNumber = createNextVersion(parentId,
//                        resource.getLastUpdaterUserName(),
//                        resource.getLastModified().getTime(),
//                        connection);
//
//                String selectSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//                PreparedStatement s = connection.prepareStatement(selectSql);
//                s.setLong(1, parentId);
//                s.setLong(2, artifactVersionNumber);
//                ResultSet result = s.executeQuery();
//
//                ArrayList dependeyMap = new ArrayList();
//
//                // to see whether the parent node is there in the table , if not need to add that
//                while (result.next()) {
//
//                    long daid = result.getLong("DAID");
//
//                    if (daid != resource.getId()) {
//                        long dvn = result.getLong("DVN");
//                        PreparedStatement ps = getStatementForDependencyTable(connection,
//                                parentId,
//                                nextVersionNumber,
//                                daid, dvn);
//                        dependeyMap.add(ps);
//                    }
//                }
//
//                if (!delete) {
//                    PreparedStatement ds = getStatementForDependencyTable(connection,
//                            parentId,
//                            nextVersionNumber,
//                            resource.getId(),
//                            versionNumber);
//                    dependeyMap.add(ds);
//                }
//
//                for (Object aDependeyMap : dependeyMap) {
//                    PreparedStatement preparedStatement = (PreparedStatement)aDependeyMap;
//                    preparedStatement.executeUpdate();
//                }
//
//                return nextVersionNumber;
//            }
//
//        } else {
//            // TODO , I think we do not need to add the entry here , since when adding a child node,
//            // if the parent is not there then we will add that
//        }
//
//        return -1;
//    }
//
//    public long getLatestVersionNumber(long resourceId, Connection connection) throws SQLException {
//
//        String sql = "SELECT MAX(VN) FROM VERSIONS WHERE AID=?";
//        PreparedStatement s = connection.prepareStatement(sql);
//        s.setLong(1, resourceId);
//        ResultSet result = s.executeQuery();
//
//        if (result.next()) {
//            return result.getLong(1);
//        }
//
//        return -1;
//    }
//
//    public String[] getVersionNumbers(long resourceId, Connection connection) throws SQLException {
//
//        String SQL = "SELECT VN FROM VERSIONS WHERE AID=? ORDER BY VN DESC";
//        PreparedStatement s = connection.prepareStatement(SQL);
//        s.setLong(1, resourceId);
//        ResultSet result = s.executeQuery();
//        ArrayList versionNumbers = new ArrayList();
//        while (result.next()) {
//            versionNumbers.add("" + result.getLong("VN"));
//        }
//        return (String[])versionNumbers.toArray(new String[versionNumbers.size()]);
//    }
//
//    public void restore(long resourceId, long toVersion, Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        ResourceImpl oldArtifact = getResourceByID(resourceId, toVersion, connection);
//        if (User.getCurrentUser() != null) {
//            oldArtifact.setLastUpdaterUserName(User.getCurrentUser());
//        }
//        String plainPath = oldArtifact.getPath();
//        if (oldArtifact.getPath().indexOf(";version=") != -1) {
//            String[] parts = oldArtifact.getPath().split(";version=");
//            plainPath = parts[0];
//        }
//        update(plainPath, oldArtifact, connection);
//        addResourceVersion(oldArtifact, connection);
//
//        if (oldArtifact.isDirectory()) {
//            activateDirectory(oldArtifact, toVersion, connection);
//            String selectChildSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//            PreparedStatement selectps = connection.prepareStatement(selectChildSql);
//            selectps.setLong(1, resourceId);
//            selectps.setLong(2, toVersion);
//            ResultSet childResult = selectps.executeQuery();
//            ArrayList dependencyList = new ArrayList();
//            while (childResult.next()) {
//                long daid = childResult.getLong("DAID");
//                markActivated(daid, connection);
//                long dvn = childResult.getLong("DVN");
//                long versionNumber = getLatestVersionNumber(resourceId, connection);
//                PreparedStatement ps = getStatementForDependencyTable(connection,
//                        resourceId, versionNumber,
//                        daid, dvn);
//                dependencyList.add(ps);
//            }
//
//            for (Object aDependencyList : dependencyList) {
//                PreparedStatement preparedStatement = (PreparedStatement)aDependencyList;
//                preparedStatement.executeUpdate();
//            }
//        }
//    }
//
//    /**
//     * To delete a resource , what actually happen here is that update the version table with the
//     * new data and resource will not actually removed from the table
//     *
//     * @param resource   : Resource to be deleted
//     * @param connection : Connection to the DB
//     * @throws java.sql.SQLException : if something went wrong
//     */
//    public void deleteResource(ResourceImpl resource,
//                               Connection connection)
//            throws SQLException, IOException, RegistryException {
//        long versionNumber = getLatestVersionNumber(resource.getId(), connection);
//        updateDependency(resource, versionNumber, true, connection);
//    }
//
//    private long createNextVersion(long resourceID,
//                                   String lastUpdaterUserName,
//                                   long lastModifiedTime,
//                                   Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        long maxVersion = getLatestVersionNumber(resourceID, connection);
//        if (maxVersion == -1) {
//            maxVersion = 0;
//        }
//
//        // here maxVersion is always >0
//        maxVersion = maxVersion + 1;
//
//        ResourceImpl resource = new ResourceImpl();
//        resource.setId(resourceID);
//        if (lastUpdaterUserName == null) {
//            lastUpdaterUserName = User.getCurrentUser();
//        }
//        resource.setLastUpdaterUserName(lastUpdaterUserName);
//        resource.setLastModified(new Date(lastModifiedTime));
//        insertToVersionTable(resource, connection);
//
//        return maxVersion;
//    }
//
//    private PreparedStatement getStatementForDependencyTable(Connection connection,
//                                                             long parentId,
//                                                             long nextVersionNumber,
//                                                             long daid,
//                                                             long dvn) throws SQLException {
//
//        String SQL = "INSERT INTO DEPENDENCY (AID, VN , DAID , DVN) VALUES (?,? ,?,?)";
//        PreparedStatement ps = connection.prepareStatement(SQL);
//        ps.setLong(1, parentId);
//        ps.setLong(2, nextVersionNumber);
//        ps.setLong(3, daid);
//        ps.setLong(4, dvn);
//        return ps;
//    }
//
//
//    /**
//     * This method is use to see whether a give resource is active or not , one can delete a
//     * resource and try to access that giving the path of the resource in that case we should not
//     * return the resource if it is deleted.
//     *
//     * @param resourcePath : Path of the resource
//     * @param connection   : Connection to DB
//     * @return : return true if the resource is active , else false
//     */
//    public boolean isResourceActive(String resourcePath, Connection connection) {
//        String[] parts = resourcePath.split(RegistryConstants.PATH_SEPARATOR);
//        String currentPath = "";
//        int current = 0;
//        if (parts.length > 0) {
//            while (current < parts.length) {
//                currentPath = currentPath + RegistryConstants.PATH_SEPARATOR + parts[current];
//                if (!getResourceStatus(resourcePath, connection)) {
//                    return false;
//                }
//                current++;
//            }
//        }
//        return true;
//    }
//
//    /**
//     * Will check whether the status of the given resource is active in the DB ., this method differ
//     * from isResourceActive because this is actually call the DB Not the other
//     *
//     * @param resourcePath : path to resource
//     * @param connection   : connection to DB
//     * @return : If something went wrong
//     */
//    private boolean getResourceStatus(String resourcePath, Connection connection) {
//        try {
//            String SQL = "SELECT STATE FROM ARTIFACTS WHERE PATH=?";
//            PreparedStatement stateStm = connection.prepareStatement(SQL);
//            stateStm.setString(1, resourcePath);
//            ResultSet results = stateStm.executeQuery();
//            if (results.next()) {
//                int state = results.getInt(1);
//                if (RegistryConstants.ACTIVE_STATE == state) {
//                    return true;
//                }
//            }
//        } catch (SQLException e) {
//            log.debug("Inside getResourceStatus trying to access the path: " + resourcePath +
//                    " error message" + e.getMessage());
//        }
//        return false;
//    }
//
//    private String getParentPath(String path) {
//
//        String[] parts = path.split(RegistryConstants.PATH_SEPARATOR);
//        String parentPath = "";
//
//        if (parts.length > 2) {
//            for (int i = 1; i < parts.length - 1; i++) {
//                parentPath = parentPath + "/" + parts[i];
//
//            }
//        } else {
//            parentPath = "/";
//        }
//
//        return parentPath;
//    }
//
//    /**
//     * This method will first split the given path and then try to create directory for each part
//     * for example if the path is "/abc/xyx/r1" , then first it will see whether the resource "/abc"
//     * is there if it is not there then it will create that else go to "/abc/xyz" , and see whether
//     * the resource is there , if so continue the same procedure
//     *
//     * @param path   : Location where we need to add the resource
//     * @param conn   : DB connection
//     * @param userID : user
//     * @param realm  : Realm
//     * @throws SQLException      : Something went wrong
//     * @throws RegistryException : Something went wrong
//     */
//    private void createParentCollections(String path,
//                                         Connection conn,
//                                         String userID,
//                                         UserRealm realm)
//            throws SQLException, IOException, RegistryException {
//
//        String[] parts = path.split(RegistryConstants.PATH_SEPARATOR);
//
//        String currentPath = RegistryConstants.ROOT_PATH + parts[1];
//        for (int i = 2; i < parts.length; i++) {
//            ResourceImpl currentCollection = getLatestVersion(currentPath, conn);
//            if (currentCollection == null) {
//                currentCollection = new CollectionImpl();
//                currentCollection.setPath(currentPath);
//                currentCollection.setAuthorUserName(userID);
//                currentCollection.setLastUpdaterUserName(userID);
//                add(currentCollection, conn);
//                AuthorizationUtil.setDefaultAuthorizations(realm, currentPath, userID);
//            }
//            currentPath = currentPath + RegistryConstants.PATH_SEPARATOR + parts[i];
//        }
//    }
//
////    private void deleteDirectory(Resource collection, Connection conn)
//>>>>>>> .r15909
//            throws SQLException, RegistryException {
//
//        // first update the artifacts table
//
//        String sql =
//                "UPDATE ARTIFACTS SET MEDIA_TYPE=?, DIRECTORY=?, STATE=?, AUTHOR=?, DESCRIPTION=? WHERE PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//
//        s.setString(1, resource.getMediaType());
//        s.setInt(2, resource.isDirectory() ? 1 : 0);
//        s.setInt(3, resource.getState());
//        s.setString(4, resource.getAuthorUserName());
//        s.setString(5, resource.getDescription());
//
//        s.setString(6, path);
//
//        s.executeUpdate();
//
//        // remove existing properties for the updated artifact
//        removeProperties(resource.getId(), conn);
//
//        // now add the updated properties to the properties table
//        addProperties(resource.getId(), resource.getProperties(), conn);
//    }
//
//    public void markDeleted(String path, Connection conn) throws SQLException {
//
//        String sql = "UPDATE ARTIFACTS SET STATE=? WHERE PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setInt(1, RegistryConstants.DELETED_STATE);
//        s.setString(2, path);
//        s.executeUpdate();
//    }
//
//    public void markActivated(long id, Connection conn) throws SQLException {
//
//        String sql = "UPDATE ARTIFACTS SET STATE=? WHERE AID=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setInt(1, RegistryConstants.ACTIVE_STATE);
//        s.setLong(2, id);
//        s.executeUpdate();
//    }
//
//
//    public void addProperties(long resourceID, Properties props, Connection conn)
//            throws SQLException {
//
//        String propSQL = "INSERT INTO PROPERTIES (AID, PKEY, PVALUE) VALUES (?,?,?)";
//        PreparedStatement s2 = conn.prepareStatement(propSQL);
//
//        if (props != null) {
//
//            Iterator i = props.keySet().iterator();
//            while (i.hasNext()) {
//                String key = (String)i.next();
//
//                List propValues = (List) props.get(key);
//                if (propValues != null) {
//                    Iterator<String> iValues = propValues.iterator();
//                    while (iValues.hasNext()) {
//                        String value = iValues.next();
//
//                        s2.setLong(1, resourceID);
//                        s2.setString(2, key);
//                        s2.setString(3, value);
//
//                        s2.executeUpdate();
//                        s2.clearParameters();
//                    }
//                }
//
//                //String value = (String)props.get(key);
//                //
//                //s2.setLong(1, resourceID);
//                //s2.setString(2, key);
//                //s2.setString(3, value);
//                //
//                //s2.executeUpdate();
//                //s2.clearParameters();
//            }
//        }
//    }
//
//    /**
//     * Adds dependencyPaths to the given version of a resource. If dependency path does not contain
//     * a version number, latest version of the dependency will be used.
//     */
//    public void addDependencies(
//            long resourceID, long version, String[] dependencyPaths, Connection conn)
//            throws SQLException, RegistryException {
//
//        String depAddSQL = "INSERT INTO DEPENDENCY_MANAGEMENT (AID, VN, DAID, DVN, DTYPE) " +
//                "VALUES (?,?,?,?,?)";
//        PreparedStatement addSt = conn.prepareStatement(depAddSQL);
//
//        String checkSQL = "SELECT AID FROM DEPENDENCY_MANAGEMENT " +
//                "WHERE AID=? AND VN=? AND DAID=? AND DVN=? AND DTYPE=?";
//        PreparedStatement checkSt = conn.prepareStatement(checkSQL);
//
//        for (String dependencyPath : dependencyPaths) {
//
//            VersionedPath versionedPath = RegistryUtils.getVersionedPath(dependencyPath);
//            if (versionedPath.getVersion() == -1) {
//                versionedPath.setVersion(getCurrentVersionNumber(versionedPath.getPath(), conn));
//            }
//
//            long dependencyID = getResourceID(versionedPath.getPath(), conn);
//
//            checkSt.setLong(1, resourceID);
//            checkSt.setLong(2, version);
//            checkSt.setLong(3, dependencyID);
//            checkSt.setLong(4, versionedPath.getVersion());
//            checkSt.setString(5, RegistryConstants.DEFAULT_DEPENDENCY);
//
//            ResultSet result = checkSt.executeQuery();
//            if (!result.next()) {
//
//                addSt.setLong(1, resourceID);
//                addSt.setLong(2, version);
//                addSt.setLong(3, dependencyID);
//                addSt.setLong(4, versionedPath.getVersion());
//                addSt.setString(5, RegistryConstants.DEFAULT_DEPENDENCY);
//
//                addSt.executeUpdate();
//                addSt.clearParameters();
//            }
//
//            checkSt.clearParameters();
//        }
//    }
//
//    /**
//     * Adds dependencies to the given version of a resource. Note that only the first level
//     * dependencies are added as other dependencies are not associated with this resource.
//     */
//    public void addDependencies(long resourceID,
//                                long version,
//                                DependencyChain[] dependencies,
//                                Connection conn)
//            throws SQLException, RegistryException {
//
//        String depAddSQL =
//                "INSERT INTO DEPENDENCY_MANAGEMENT (AID, VN, DAID, DVN, DTYPE) VALUES (?,?,?,?,?)";
//        PreparedStatement addSt = conn.prepareStatement(depAddSQL);
//
//        String checkSQL =
//                "SELECT AID FROM DEPENDENCY_MANAGEMENT WHERE AID=? AND VN=? AND DAID=? AND DVN=? AND DTYPE=?";
//        PreparedStatement checkSt = conn.prepareStatement(checkSQL);
//
//        for (DependencyChain dependency : dependencies) {
//
//            VersionedPath versionedPath =
//                    RegistryUtils.getVersionedPath(dependency.getDependencyPath());
//            if (versionedPath.getVersion() == -1) {
//                versionedPath.setVersion(getCurrentVersionNumber(versionedPath.getPath(), conn));
//            }
//
//            long dependencyID = getResourceID(versionedPath.getPath(), conn);
//
//            checkSt.setLong(1, resourceID);
//            checkSt.setLong(2, version);
//            checkSt.setLong(3, dependencyID);
//            checkSt.setLong(4, versionedPath.getVersion());
//            checkSt.setString(5, RegistryConstants.DEFAULT_DEPENDENCY);
//
//            ResultSet result = checkSt.executeQuery();
//            if (!result.next()) {
//
//                addSt.setLong(1, resourceID);
//                addSt.setLong(2, version);
//                addSt.setLong(3, dependencyID);
//                addSt.setLong(4, versionedPath.getVersion());
//                addSt.setString(5, RegistryConstants.DEFAULT_DEPENDENCY);
//
//                addSt.executeUpdate();
//                addSt.clearParameters();
//            }
//
//            checkSt.clearParameters();
//        }
//    }
//
//    public void removeProperties(long resourceID, Connection conn) throws SQLException {
//
//        String removePropsSQL = "DELETE FROM PROPERTIES WHERE AID=?";
//        PreparedStatement s2 = conn.prepareStatement(removePropsSQL);
//        s2.setLong(1, resourceID);
//        s2.executeUpdate();
//    }
//
//    public boolean resourceExist(String path, Connection conn) throws SQLException {
//
//        String sql = "SELECT COUNT(A.AID) FROM ARTIFACTS A WHERE A.PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setString(1, path);
//
//        ResultSet result = s.executeQuery();
//        long count = 0;
//        if (result.next()) {
//            count = result.getLong(1);
//        }
//
//        return count == 1;
//    }
//
//    public boolean resourceActive(String path, Connection conn) throws SQLException {
//
//        String sql = "SELECT STATE FROM ARTIFACTS A WHERE A.PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setString(1, path);
//
//        ResultSet result = s.executeQuery();
//        long count = 0;
//        if (result.next()) {
//            count = result.getLong(1);
//        }
//        return RegistryConstants.ACTIVE_STATE == count;
//    }
//
//    public long getResourceID(String path, Connection conn) throws SQLException {
//
//        String sql = "SELECT A.AID FROM ARTIFACTS A WHERE A.PATH=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setString(1, path);
//
//        ResultSet result = s.executeQuery();
//        if (result.next()) {
//            return result.getLong(DatabaseConstants.AID_FIELD);
//        }
//
//        return -1;
//    }
//
//    public String getResourcePath(long id, Connection conn) throws SQLException {
//
//        String sql = "SELECT A.PATH FROM ARTIFACTS A WHERE A.AID=?";
//
//        PreparedStatement s = conn.prepareStatement(sql);
//        s.setLong(1, id);
//
//        ResultSet result = s.executeQuery();
//        if (result.next()) {
//            return result.getString(DatabaseConstants.PATH_FIELD);
//        }
//        return null;
//    }
//
//    /**
//     * This method will copy a resource from oldpath to newpath , the internal implementation is
//     * such that copy all the resources from oldpath to new path including tags , comments and ratings.
//     *
//     * @param oldPath : Current path of the resource
//     * @param newPath : Where to move the resource
//     * @param userId  : current user
//     * @param realm   : Realm
//     * @throws org.wso2.registry.RegistryException
//     *          : If something went wrong
//     */
//    public void renameWithoutDelete(String oldPath,
//                               String newPath,
//                               String userId,
//                               UserRealm realm,
//                               Registry registry) throws SQLException, RegistryException, IOException {
//        Connection conn = dataSource.getConnection();
//        ResourceImpl resource = getLatestVersion(oldPath, conn);
//        String resourcePath = resource.getPath();
//        long resourceID = resource.getId();
//        //to see whether the patent node is there in the table , if not need to add that
//        createParentCollections(newPath, conn, userId, realm);
//        // if the resource is a directory then need to populate the dependecy table with
//        // the new resource id , while keeping the old one as it is
//        if (resource.isDirectory()) {
//            copyResource(oldPath, newPath, registry, true, conn);
//        } else {
//            // Then its just need to add the resource and no need to update any of the
//            // dependecy tables
//            resource.setPath(newPath);
//            if (resource.getAuthorUserName() == null) {
//                resource.setAuthorUserName(userId);
//            }
//            InputStream in = resource.getContentStream();
//            resource.setLastUpdaterUserName(userId);
//            add(resource, conn);
//            AuthorizationUtil.setDefaultAuthorizations(realm, newPath, userId);
//            long newResourceID = getResourceID(newPath, conn);
//            resource.setId(newResourceID);
//
//            resource.setContentStream(in);
//            addResourceVersion(resource, conn);
//            resource.setPath(resourcePath);
//
//            long fromResourceId = getResourceID(oldPath, conn);
//            //copying the comments
//            CommentsDAO commentsDAO = new CommentsDAO();
//            commentsDAO.copyComments(oldPath, newResourceID, conn);
//            //coping the tags
//            TagsDAO tags = new TagsDAO(dataSource);
//            tags.copyTags(fromResourceId, newResourceID, conn);
//
//            // copy ratings
//            RatingsDAO ratingsDAO = new RatingsDAO();
//            ratingsDAO.copyRatings(fromResourceId, newResourceID, conn);
//
//        }
//    }
//    /**
//     * This method will move a resource from oldpath to newpath , the internal implementation is
//     * such that frit the release will be deleted from oldPath parent and will be added to the
//     * newptah so if the oldpath is "foo/bar/r1" then the r1 will be removed from foo/bar. However
//     * later we can restore and get everything working fine
//     *
//     * @param oldPath : Current path of the resource
//     * @param newPath : Where to move the resource
//     * @param conn    : Connection to DB
//     * @param userId  : current user
//     * @param realm   : Realm
//     * @throws org.wso2.registry.RegistryException
//     *          : If something went wrong
//     */
//    public void renameResource(String oldPath,
//                               String newPath,
//                               Connection conn,
//                               String userId,
//                               UserRealm realm,
//                               Registry registry)
//            throws SQLException, IOException, RegistryException {
//
//        ResourceImpl resource = getLatestVersion(oldPath, conn);
//
//        // calling the getContentStream loads the input stream to the resource. so we can
//        // access it even after changing the original resource.
//        resource.setContentStream(resource.getContentStream());
//
//        String resourcePath = resource.getPath();
//        long resourceID = resource.getId();
//        //to see whether the patent node is there in the table , if not need to add that
//        createParentCollections(newPath, conn, userId, realm);
//        // if the resource is a directory then need to populate the dependecy table with
//        // the new resource id , while keeping the old one as it is
//        if (resource.isDirectory()) {
//            copyResource(oldPath, newPath, registry, true, conn);
//        } else {
//            // Then its just need to add the resource and no need to update any of the
//            // dependecy tables
//            resource.setPath(newPath);
//            if (resource.getAuthorUserName() == null) {
//                resource.setAuthorUserName(userId);
//            }
//            resource.setLastUpdaterUserName(userId);
//            markDeleted(resourcePath, conn);
//            deleteResource(resource, conn);
//            add(resource, conn);
//            AuthorizationUtil.setDefaultAuthorizations(realm, newPath, userId);
//            long newResourceID = getResourceID(newPath, conn);
//            resource.setId(newResourceID);
//            addResourceVersion(resource, conn);
//            resource.setPath(resourcePath);
//            resource.setId(resourceID);
//
//            long fromResourceId = getResourceID(oldPath, conn);
//            //copying the comments
//            CommentsDAO commentsDAO = new CommentsDAO();
//            commentsDAO.copyComments(oldPath, resourceID, conn);
//            //coping the tags
//            TagsDAO tags = new TagsDAO(dataSource);
//            tags.copyTags(fromResourceId, resourceID, conn);
//
//            // copy ratings// set the datasource to fetch the content.
//            resource.setDataSource(dataSource);
//            RatingsDAO ratingsDAO = new RatingsDAO();
//            ratingsDAO.copyRatings(fromResourceId, resourceID, conn);
//
//        }
//        //prepareToDelete(resource.getId(), conn);
//        //resourceDAO.delete(resource.getResourcePath(), conn);
//    }
//
//
//    /**
//     * This method use to copy a resource from given location to some other location When we do so
//     * all the resource properties , tags  , comments and everything will be copy into new location
//     *
//     * @param fromPath   : Which collection to copy
//     * @param toPath     : Where to copy
//     * @param registry   : Instance of a registry
//     * @param useOrginal : to indicate whether firt time call or not
//     * @throws RegistryException
//     */
//    private void copyResource(String fromPath,
//                              String toPath,
//                              Registry registry,
//                              boolean useOrginal,
//                              Connection conn) throws RegistryException {
//        ResourceImpl resource = (ResourceImpl)registry.get(fromPath);
//        if (resource != null) {
//
//            String resourcePath = resource.getPath();
//            int verionIndex = resourcePath.indexOf("?");
//            if (verionIndex > 0) {
//                resourcePath = resourcePath.substring(0, verionIndex);
//            }
//            int slashIndex = resourcePath.lastIndexOf("/");
//            //getting only the last part of the resource path
//            resourcePath = resourcePath.substring(slashIndex, resourcePath.length());
//
//            String currentPath;
//            if (!useOrginal) {
//                currentPath = toPath + resourcePath;
//            } else {
//                currentPath = toPath;
//            }
//
//            if (resource.isDirectory()) {
//                String childNodes[] = (String[])resource.getContent();
//                for (String childNode : childNodes) {
//                    copyResource(childNode, currentPath, registry, false, conn);
//                }
//            }
//            InputStream in = resource.getContentStream();
//            resource.setPath(currentPath);
//            resource.setContentStream(in);
//            registry.put(currentPath, resource);
//            try {
//                long resourceId = getResourceID(currentPath, conn);
//                long fromResourceId = getResourceID(fromPath, conn);
//                //copying the comments
//                CommentsDAO commentsDAO = new CommentsDAO();
//                commentsDAO.copyComments(fromPath, resourceId, conn);
//                //coping the tags
//                TagsDAO tags = new TagsDAO(dataSource);
//                tags.copyTags(fromResourceId, resourceId, conn);
//
//                // copy ratings
//                RatingsDAO ratingsDAO = new RatingsDAO();
//                ratingsDAO.copyRatings(fromResourceId, resourceId, conn);
//            } catch (SQLException e) {
//                log.info(e);
//            }
//        } else {
//            log.info("No resource found for : " + fromPath);
//        }
//    }
//
//    public long addResourceVersion(ResourceImpl resource, Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        if (resource.getLastModified() == null) {
//            resource.setLastModified(new java.util.Date());
//        }
//
//        long versionNumber = insertToVersionTable(resource, connection);
//
//        //updating max version table
//        updateDependency(resource, versionNumber, false, connection);
//        return versionNumber;
//    }
//
//    private long insertToVersionTable(ResourceImpl resource, Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        String sql =
//                "INSERT INTO VERSIONS (AID, VN, CONTENT, AUTHOR, UPDATED_TIME) VALUES (?,?,?,?,?)";
//        PreparedStatement statement = connection.prepareStatement(sql);
//        statement.setLong(1, resource.getId());
//
//        // Need to get the old version and increment that
//        // Select VID from latest table ,
//        // if it is there then find from that  , if it is not there then we need ti start from 0
//        long versionNumber = getLatestVersionNumber(resource.getId(), connection);
//        if (versionNumber == -1) {
//            versionNumber = 1;
//        } else {
//            //incrementing the version number
//            versionNumber = versionNumber + 1;
//        }
//        statement.setLong(2, versionNumber);
//
//        InputStream contentStream = resource.getContentStream();
//        if (contentStream != null) {
//
//            File tempFile = File.createTempFile("reg", "tmp");
//            OutputStream fileStream = new BufferedOutputStream(new FileOutputStream(tempFile));
//            InputStream bufferedIn = new BufferedInputStream(contentStream);
//
//            byte[] dataChunk = new byte[1024];
//            int byteCount;
//            while ((byteCount = bufferedIn.read(dataChunk)) != -1) {
//                fileStream.write(dataChunk, 0, byteCount);
//            }
//            fileStream.flush();
//            bufferedIn.close();
//            fileStream.close();
//
//            // there is no use of content stream after it is closed. so we can set it to null to
//            // avoid using it again.
//            resource.setContentStream(null);
//
//            InputStream tempFileStream = new BufferedInputStream(new FileInputStream(tempFile));
//            long contentLength = tempFile.length();
//
//            statement.setBinaryStream(3, tempFileStream, (int)contentLength);
//
//        } else {
//            statement.setBytes(3, convertToBytes(resource.getContent()));
//        }
//
//        //byte[] bytes = convertToBytes(content);
//
//        String userName = resource.getLastUpdaterUserName();
//        if (userName == null) {
//            userName = CurrentSession.getUser();
//        }
//        statement.setString(4, userName);
//        statement.setTimestamp(5, new Timestamp(System.currentTimeMillis()));
//        statement.executeUpdate();
//
//        return versionNumber;
//    }
//
//    public static byte[] convertToBytes(Object object) {
//        if (object instanceof byte[])
//            return (byte[])object;
//        if (object instanceof String)
//            return ((String)object).getBytes();
//        if (object instanceof DataHandler) {
//            try {
//                object = ((DataHandler)object).getInputStream();
//            } catch (IOException e) {
//                return null;
//            }
//        }
//        if (object instanceof InputStream) {
//            // TODO - fix this to really work.
//            InputStream is = (InputStream)object;
//            byte[] bytes;
//            try {
//                int avail = is.available();
//                bytes = new byte[avail];
//                is.read(bytes);
//            } catch (IOException e) {
//                return null;
//            }
//            return bytes;
//        }
//
//        return null;
//    }
//
//    private void updateDependency(ResourceImpl resource,
//                                  long versionNumber,
//                                  boolean delete, Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        // updating dependency table , so that we can rollbackTransaction to a particular version
//        // updating for the current resource
//        long parentNextVersionNumber =
//                updateDependencyTable(resource, versionNumber, delete, connection);
//
//        // a/b/c/r1.wsdl
//        // Next a/b/c
//        // Next a/b
//        // Next a
//        if (parentNextVersionNumber != -1) {
//
//            // updating its parent
//            String path = resource.getPath();
//            while (path != null && path.indexOf("/") > -1) {
//
//                int lastIndex = path.lastIndexOf("/");
//                String parentPath = path.substring(0, lastIndex);
//                ResourceImpl parentArtifact = getLatestVersion(parentPath, connection);
//
//                if (parentArtifact != null) {
//                    path = parentArtifact.getPath();
//                    parentArtifact.setLastUpdaterUserName(resource.getLastUpdaterUserName());
//                    parentNextVersionNumber = updateDependencyTable(
//                            parentArtifact, parentNextVersionNumber, false, connection);
//
//                    if (parentNextVersionNumber == -1) {
//                        break;
//                    }
//                } else {
//                    break;
//                }
//            }
//        }
//    }
//
//    /**
//     * @param resource      : Artifact we need to update itself and its immediate parent
//     * @param versionNumber : Version number of the artifact
//     * @param delete        : delete or adding
//     * @param connection    : DB connection
//     * @return : Will return the resource version of the parent resource
//     * @throws SQLException : if something went wrong
//     */
//    private long updateDependencyTable(ResourceImpl resource,
//                                       long versionNumber,
//                                       boolean delete, Connection connection)
//            throws SQLException, IOException, RegistryException {
//        /**
//         *        D0
//         *    D1      D2
//         *  D3  R1    R2
//         *
//         *  First fine D1 V0
//         */
//        // Checking whether the path is null or top most directory
//        // Checking whether resource is root node or not
//
//        String path = resource.getPath();
//
//        // Checking whether the path is null or top most directory
//        // if (path != null && path.indexOf("/") > -1) {
//        if (path != null && !path.equals(RegistryConstants.ROOT_PATH)) {
//
//            int lastIndex = path.lastIndexOf("/");
//            String parentPath = RegistryConstants.ROOT_PATH;
//            if (lastIndex != 0) {
//                parentPath = path.substring(0, lastIndex);
//            }
//
//            if ("".equals(parentPath)) {
//                //TODO : Need to think the logic here
//
//            } else {
//
//                long parentId = getResourceID(parentPath, connection);
//
//                if (resource.getLastModified() == null) {
//                    resource.setLastModified(new java.util.Date());
//                }
//
//                // Need to get the parent's parent and update the and update the
//
//                long artifactVersionNumber = getCurrentVersionNumber(parentPath, connection);
////                long artifactVersionNumber = getLatestVersionNumber(parentId, connection);
//
//                long nextVersionNumber = createNextVersion(parentId,
//                        resource.getLastUpdaterUserName(),
//                        resource.getLastModified().getTime(),
//                        connection);
//
//                String selectSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//                PreparedStatement s = connection.prepareStatement(selectSql);
//                s.setLong(1, parentId);
//                s.setLong(2, artifactVersionNumber);
//                ResultSet result = s.executeQuery();
//
//                ArrayList dependeyMap = new ArrayList();
//
//                // to see whether the parent node is there in the table , if not need to add that
//                while (result.next()) {
//
//                    long daid = result.getLong("DAID");
//
//                    if (daid != resource.getId()) {
//                        long dvn = result.getLong("DVN");
//                        PreparedStatement ps = getStatementForDependencyTable(connection,
//                                parentId,
//                                nextVersionNumber,
//                                daid, dvn);
//                        dependeyMap.add(ps);
//                    }
//                }
//
//                if (!delete) {
//                    PreparedStatement ds = getStatementForDependencyTable(connection,
//                            parentId,
//                            nextVersionNumber,
//                            resource.getId(),
//                            versionNumber);
//                    dependeyMap.add(ds);
//                }
//
//                for (Object aDependeyMap : dependeyMap) {
//                    PreparedStatement preparedStatement = (PreparedStatement)aDependeyMap;
//                    preparedStatement.executeUpdate();
//                }
//
//                return nextVersionNumber;
//            }
//
//        } else {
//            // TODO , I think we do not need to add the entry here , since when adding a child node,
//            // if the parent is not there then we will add that
//        }
//
//        return -1;
//    }
//
//    public long getLatestVersionNumber(long resourceId, Connection connection) throws SQLException {
//
//        String sql = "SELECT MAX(VN) FROM VERSIONS WHERE AID=?";
//        PreparedStatement s = connection.prepareStatement(sql);
//        s.setLong(1, resourceId);
//        ResultSet result = s.executeQuery();
//
//        if (result.next()) {
//            return result.getLong(1);
//        }
//
//        return -1;
//    }
//
//    public String[] getVersionNumbers(long resourceId, Connection connection) throws SQLException {
//
//        String SQL = "SELECT VN FROM VERSIONS WHERE AID=? ORDER BY VN DESC";
//        PreparedStatement s = connection.prepareStatement(SQL);
//        s.setLong(1, resourceId);
//        ResultSet result = s.executeQuery();
//        ArrayList versionNumbers = new ArrayList();
//        while (result.next()) {
//            versionNumbers.add("" + result.getLong("VN"));
//        }
//        return (String[])versionNumbers.toArray(new String[versionNumbers.size()]);
//    }
//
//    public void restore(long resourceId, long toVersion, Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        ResourceImpl oldArtifact = getResourceByID(resourceId, toVersion, connection);
//        if (CurrentSession.getUser() != null) {
//            oldArtifact.setLastUpdaterUserName(CurrentSession.getUser());
//        }
//        String plainPath = oldArtifact.getPath();
//        if (oldArtifact.getPath().indexOf("?v=") != -1) {
//            String[] parts = oldArtifact.getPath().split("\\?v=");
//            plainPath = parts[0];
//        }
//        update(plainPath, oldArtifact, connection);
//        addResourceVersion(oldArtifact, connection);
//
//        if (oldArtifact.isDirectory()) {
//            activateDirectory(oldArtifact, connection);
//            String selectChildSql = "SELECT DAID, DVN FROM DEPENDENCY WHERE AID=? AND VN=?";
//            PreparedStatement selectps = connection.prepareStatement(selectChildSql);
//            selectps.setLong(1, resourceId);
//            selectps.setLong(2, toVersion);
//            ResultSet childResult = selectps.executeQuery();
//            ArrayList dependencyList = new ArrayList();
//            while (childResult.next()) {
//
//                long daid = childResult.getLong("DAID");
//                markActivated(daid, connection);
//                long dvn = childResult.getLong("DVN");
//                long versionNumber = getLatestVersionNumber(resourceId, connection);
//                PreparedStatement ps = getStatementForDependencyTable(connection,
//                        resourceId, versionNumber,
//                        daid, dvn);
//                dependencyList.add(ps);
//            }
//
//            for (Object aDependencyList : dependencyList) {
//                PreparedStatement preparedStatement = (PreparedStatement)aDependencyList;
//                preparedStatement.executeUpdate();
//            }
//        }
//    }
//
//    /**
//     * To delete a resource , what actually happen here is that update the version table with the
//     * new data and resource will not actually removed from the table
//     *
//     * @param resource   : Resource to be deleted
//     * @param connection : Connection to the DB
//     * @throws java.sql.SQLException : if something went wrong
//     */
//    public void deleteResource(ResourceImpl resource,
//                               Connection connection)
//            throws SQLException, IOException, RegistryException {
//        long versionNumber = getLatestVersionNumber(resource.getId(), connection);
//        updateDependency(resource, versionNumber, true, connection);
//    }
//
//    private long createNextVersion(long resourceID,
//                                   String lastUpdaterUserName,
//                                   long lastModifiedTime,
//                                   Connection connection)
//            throws SQLException, IOException, RegistryException {
//
//        long maxVersion = getLatestVersionNumber(resourceID, connection);
//        if (maxVersion == -1) {
//            maxVersion = 0;
//        }
//
//        // here maxVersion is always >0
//        maxVersion = maxVersion + 1;
//
//        ResourceImpl resource = new ResourceImpl();
//        resource.setId(resourceID);
//        if (lastUpdaterUserName == null) {
//            lastUpdaterUserName = CurrentSession.getUser();
//        }
//        resource.setLastUpdaterUserName(lastUpdaterUserName);
//        resource.setLastModified(new Date(lastModifiedTime));
//        insertToVersionTable(resource, connection);
//
//        return maxVersion;
//    }
//
//    private PreparedStatement getStatementForDependencyTable(Connection connection,
//                                                             long parentId,
//                                                             long nextVersionNumber,
//                                                             long daid,
//                                                             long dvn) throws SQLException {
//
//        String SQL = "INSERT INTO DEPENDENCY (AID, VN , DAID , DVN) VALUES (?,? ,?,?)";
//        PreparedStatement ps = connection.prepareStatement(SQL);
//        ps.setLong(1, parentId);
//        ps.setLong(2, nextVersionNumber);
//        ps.setLong(3, daid);
//        ps.setLong(4, dvn);
//        return ps;
//    }
//
//
//    /**
//     * This method is use to see whether a give resource is active or not , one can delete a
//     * resource and try to access that giving the path of the resource in that case we should not
//     * return the resource if it is deleted.
//     *
//     * @param resourcePath : Path of the resource
//     * @param connection   : Connection to DB
//     * @return : return true if the resource is active , else false
//     */
//    public boolean isResourceActive(String resourcePath, Connection connection) {
//        String[] parts = resourcePath.split(RegistryConstants.PATH_SEPARATOR);
//        String currentPath = "";
//        int current = 0;
//        if (parts.length > 0) {
//            while (current < parts.length) {
//                currentPath = currentPath + RegistryConstants.PATH_SEPARATOR + parts[current];
//                if (!getResourceStatus(resourcePath, connection)) {
//                    return false;
//                }
//                current++;
//            }
//        }
//        return true;
//    }
//
//    /**
//     * Will check whether the status of the given resource is active in the DB ., this method differ
//     * from isResourceActive because this is actually call the DB Not the other
//     *
//     * @param resourcePath : path to resource
//     * @param connection   : connection to DB
//     * @return : If something went wrong
//     */
//    private boolean getResourceStatus(String resourcePath, Connection connection) {
//        try {
//            String SQL = "SELECT STATE FROM ARTIFACTS WHERE PATH=?";
//            PreparedStatement stateStm = connection.prepareStatement(SQL);
//            stateStm.setString(1, resourcePath);
//            ResultSet results = stateStm.executeQuery();
//            if (results.next()) {
//                int state = results.getInt(1);
//                if (RegistryConstants.ACTIVE_STATE == state) {
//                    return true;
//                }
//            }
//        } catch (SQLException e) {
//            log.debug("Inside getResourceStatus trying to access the path: " + resourcePath +
//                    " error message" + e.getMessage());
//        }
//        return false;
//    }
//
//    private String getParentPath(String path) {
//
//        String[] parts = path.split(RegistryConstants.PATH_SEPARATOR);
//        String parentPath = "";
//
//        if (parts.length > 2) {
//            for (int i = 1; i < parts.length - 1; i++) {
//                parentPath = parentPath + "/" + parts[i];
//
//            }
//        } else {
//            parentPath = "/";
//        }
//
//        return parentPath;
//    }
//
//    /**
//     * This method will first split the given path and then try to create directory for each part
//     * for example if the path is "/abc/xyx/r1" , then first it will see whether the resource "/abc"
//     * is there if it is not there then it will create that else go to "/abc/xyz" , and see whether
//     * the resource is there , if so continue the same procedure
//     *
//     * @param path   : Location where we need to add the resource
//     * @param conn   : DB connection
//     * @param userID : user
//     * @param realm  : Realm
//     * @throws SQLException      : Something went wrong
//     * @throws RegistryException : Something went wrong
//     */
//    private void createParentCollections(String path,
//                                         Connection conn,
//                                         String userID,
//                                         UserRealm realm)
//            throws SQLException, IOException, RegistryException {
//
//        String[] parts = path.split(RegistryConstants.PATH_SEPARATOR);
//
//        String currentPath = RegistryConstants.ROOT_PATH + parts[1];
//        for (int i = 2; i < parts.length; i++) {
//            ResourceImpl currentCollection = getLatestVersion(currentPath, conn);
//            if (currentCollection == null) {
//                currentCollection = new CollectionImpl();
//                currentCollection.setPath(currentPath);
//                currentCollection.setAuthorUserName(userID);
//                currentCollection.setLastUpdaterUserName(userID);
//                add(currentCollection, conn);
//                AuthorizationUtil.setDefaultAuthorizations(realm, currentPath, userID);
//            }
//            currentPath = currentPath + RegistryConstants.PATH_SEPARATOR + parts[i];
//        }
//    }
//
////    private void deleteDirectory(Resource collection, Connection conn)
////            throws SQLException, RegistryException {
////        List childList = getChildren(collection.getId(), -1, conn);
////        Iterator i = childList.iterator();
////        while (i.hasNext()) {
////            Resource child = (Resource)i.next();
////            if (child.isDirectory()) {
////                deleteDirectory(child, conn);
////            } else {
////                markDeleted(child.getPath(), conn);
////                deleteResource(child, conn);
////            }
////        }
////        markDeleted(collection.getPath(), conn);
////        deleteResource(collection, conn);
////    }
//
//    private void activateDirectory(ResourceImpl collection, Connection conn) throws SQLException {
//        List childList = getChildren(collection.getId(), -1, conn);
//        Iterator i = childList.iterator();
//        while (i.hasNext()) {
//            ResourceImpl child = (ResourceImpl)i.next();
//            if (child.isDirectory()) {
//                activateDirectory(child, conn);
//            } else {
//                markActivated(child.getId(), conn);
//            }
//        }
//        markActivated(collection.getId(), conn);
//    }
//<<<<<<< .mine
//
//    private InputStream getDisconnectedStream(InputStream connectedStream) throws IOException {
//
//        if (connectedStream == null) {
//            return null;
//        }
//
//        File tempFile = File.createTempFile("reg", "tmp");
//        tempFile.deleteOnExit();
//
//        BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(tempFile));
//        byte[] contentChunk = new byte[1024];
//        int byteCount;
//        while ((byteCount = connectedStream.read(contentChunk)) != -1) {
//            out.write(contentChunk, 0, byteCount);
//        }
//        out.flush();
//        out.close();
//        connectedStream.close();
//
//        return new BufferedInputStream(new FileInputStream(tempFile));
//    }
//=======
//
//    private void activateDirectory(ResourceImpl collection, long version, Connection conn)
//            throws SQLException {
//        List childList = getChildren(collection.getId(), version, conn);
//        Iterator i = childList.iterator();
//        while (i.hasNext()) {
//            ResourceImpl child = (ResourceImpl)i.next();
//            if (child.isDirectory()) {
//                activateDirectory(child, child.getVersionNumber(), conn);
//            } else {
//                markActivated(child.getId(), conn);
//            }
//        }
//        markActivated(collection.getId(), conn);
//    }
//
//    private InputStream getDisconnectedStream(InputStream connectedStream) throws IOException {
//
//        if (connectedStream == null) {
//            return null;
//        }
//
//        File tempFile = File.createTempFile("reg", "tmp");
//        tempFile.deleteOnExit();
//
//        BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(tempFile));
//        byte[] contentChunk = new byte[1024];
//        int byteCount;
//        while ((byteCount = connectedStream.read(contentChunk)) != -1) {
//            out.write(contentChunk, 0, byteCount);
//        }
//        out.flush();
//        out.close();
//        connectedStream.close();
//
//        return new BufferedInputStream(new FileInputStream(tempFile));
//    }
//>>>>>>> .r15909
}
