/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.jdbc.handlers.builtin;

import org.wso2.registry.jdbc.handlers.Handler;
import org.wso2.registry.jdbc.handlers.RequestContext;
import org.wso2.registry.jdbc.dao.TagsDAO;
import org.wso2.registry.jdbc.dataobjects.TaggingDO;
import org.wso2.registry.jdbc.utils.Transaction;
import org.wso2.registry.*;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.sql.Connection;
import java.sql.SQLException;

public class TagCollectionURLHandler extends Handler {

    private static final Log log = LogFactory.getLog(TagCollectionURLHandler.class);

    public Resource get(RequestContext requestContext) throws RegistryException {

        String url = requestContext.getResourcePath();

        String[] parts = url.split(RegistryConstants.URL_SEPARATOR);

        if (parts.length != 2) {
            return null;
        }

        if (parts[0].length() == 0) {
            return null;
        }

        String resourcePath = parts[0];

        TagsDAO tagsDAO = new TagsDAO();
        String [] tags = tagsDAO.getTags(resourcePath);
        String tagStr = "";
        for (String tag : tags) {
            tagStr += tag;
        }

        ResourceImpl resource = new ResourceImpl();
        resource.setMediaType(RegistryConstants.TAG_MEDIA_TYPE);
        resource.setContent(tagStr);
        resource.setPath(resourcePath);
        resource.addProperty("resourcePath", resourcePath);

        return resource;
    }

    public void put(RequestContext requestContext) throws RegistryException {
    }

    public void importResource(RequestContext requestContext) throws RegistryException {
    }

    public void delete(RequestContext requestContext) throws RegistryException {
    }

    public void putChild(RequestContext requestContext) throws RegistryException {
    }

    public void importChild(RequestContext requestContext) throws RegistryException {
    }
}