/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.jdbc.handlers.filters;

import org.wso2.registry.jdbc.handlers.RequestContext;
import org.wso2.registry.RegistryException;

public class URLMatcher extends Filter {

    private String getPattern;
    private String putPattern;
    private String importPattern;
    private String deletePattern;
    private String putChildPattern;
    private String importChildPattern;

    public boolean handleGet(RequestContext requestContext) throws RegistryException {
        if (getPattern != null) {
            return requestContext.getResourcePath().matches(getPattern);
        } else {
            return false;
        }
    }

    public boolean handlePut(RequestContext requestContext) throws RegistryException {
        if (putPattern != null) {
            return requestContext.getResourcePath().matches(putPattern);
        } else {
            return false;
        }
    }

    public boolean handleImportResource(RequestContext requestContext) throws RegistryException {
        if (importPattern != null) {
            return requestContext.getResourcePath().matches(importPattern);
        } else {
            return false;
        }
    }

    public boolean handleDelete(RequestContext requestContext) throws RegistryException {
        if (deletePattern != null) {
            return requestContext.getResourcePath().matches(deletePattern);
        } else {
            return false;
        }
    }

    public boolean handlePutChild(RequestContext requestContext) throws RegistryException {
        if (putChildPattern != null) {
            return requestContext.getResourcePath().matches(putChildPattern);
        } else {
            return false;
        }
    }

    public boolean handleImportChild(RequestContext requestContext) throws RegistryException {
        if (importChildPattern != null) {
            return requestContext.getResourcePath().matches(importChildPattern);
        } else {
            return false;
        }
    }

    public String getGetPattern() {
        return getPattern;
    }

    public void setGetPattern(String getPattern) {
        this.getPattern = getPattern;
    }

    public String getPutPattern() {
        return putPattern;
    }

    public void setPutPattern(String putPattern) {
        this.putPattern = putPattern;
    }

    public String getImportPattern() {
        return importPattern;
    }

    public void setImportPattern(String importPattern) {
        this.importPattern = importPattern;
    }

    public String getDeletePattern() {
        return deletePattern;
    }

    public void setDeletePattern(String deletePattern) {
        this.deletePattern = deletePattern;
    }

    public String getPutChildPattern() {
        return putChildPattern;
    }

    public void setPutChildPattern(String putChildPattern) {
        this.putChildPattern = putChildPattern;
    }

    public String getImportChildPattern() {
        return importChildPattern;
    }

    public void setImportChildPattern(String importChildPattern) {
        this.importChildPattern = importChildPattern;
    }
}
