/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.registry.jdbc;

import junit.framework.TestCase;
import org.wso2.registry.*;
import org.wso2.registry.jdbc.realm.RegistryRealm;
import org.wso2.registry.jdbc.realm.InMemoryRegistryRealm;

public class DependencyTest extends TestCase {

    protected static Registry registry = null;
    protected static RegistryRealm realm = null;

    public void setUp() {
        try {
            if (registry == null) {
                EmbeddedRegistry embeddedRegistry = new InMemoryEmbeddedRegistry();
                registry = embeddedRegistry.getSystemRegistry();
            }
        } catch (RegistryException e) {
            fail("Failed to initialize the registry. Caused by: " + e.getMessage());
        }
    }
    //
    //public void testSettingDependenciesInResources() throws RegistryException {
    //
    //    Resource r1 = registry.newResource();
    //    r1.setContent("some content for first r1".getBytes());
    //    registry.put("/depTest/test1/r1", r1);
    //
    //    Resource r2 = registry.newResource();
    //    r2.setContent("this is dependent on r1".getBytes());
    //    r2.addDependency("/depTest/test1/r1");
    //    registry.put("/depTest/test1/r2", r2);
    //
    //    Resource r21 = registry.get("/depTest/test1/r1");
    //    Resource r22 = registry.get("/depTest/test1/r2");
    //
    //    assertTrue(containsString(r21.getDependents(), "/depTest/test1/r2"));
    //    assertTrue(containsString(r22.getDependencies(), "/depTest/test1/r1"));
    //}
    //
    //public void testSettingDependenciesFromAPI() throws RegistryException {
    //
    //    Resource r1 = registry.newResource();
    //    r1.setContent("some content for second r1".getBytes());
    //    registry.put("/depTest/test2/r1", r1);
    //
    //    Resource r2 = registry.newResource();
    //    r2.setContent("this is dependent on r2".getBytes());
    //    registry.put("/depTest/test2/r2", r2);
    //
    //    registry.addDependencies("/depTest/test2/r2", new String[] {"/depTest/test2/r1"});
    //
    //    Resource r21 = registry.get("/depTest/test2/r1");
    //    Resource r22 = registry.get("/depTest/test2/r2");
    //
    //    assertTrue(containsString(r21.getDependents(), "/depTest/test2/r2"));
    //    assertTrue(containsString(r22.getDependencies(), "/depTest/test2/r1"));
    //}
    //
    //public void testDependencyChainAnalysis() throws RegistryException {
    //
    //    Resource r1 = registry.newResource();
    //    r1.setContent("some content for second r1".getBytes());
    //    registry.put("/depTest/test3/r1", r1);
    //
    //    Resource r2 = registry.newResource();
    //    r2.setContent("this is dependent on r2".getBytes());
    //    registry.put("/depTest/test3/r2", r2);
    //
    //    Resource r3 = registry.newResource();
    //    r3.setContent("some content for second r3".getBytes());
    //    registry.put("/depTest/test3/r3", r3);
    //
    //    Resource r4 = registry.newResource();
    //    r4.setContent("this is dependent on r4".getBytes());
    //    registry.put("/depTest/test3/r4", r4);
    //
    //    Resource r5 = registry.newResource();
    //    r5.setContent("this is dependent on r5".getBytes());
    //    registry.put("/depTest/test3/r5", r5);
    //
    //    registry.addDependencies("/depTest/test3/r1", new String[] {"/depTest/test3/r2"});
    //    registry.addDependencies("/depTest/test3/r2", new String[] {"/depTest/test3/r3"});
    //    registry.addDependencies("/depTest/test3/r3", new String[] {"/depTest/test3/r4"});
    //    registry.addDependencies("/depTest/test3/r3", new String[] {"/depTest/test3/r5"});
    //
    //    DependencyChain[] dependencies1 = registry.getAllDependencies("/depTest/test3/r1");
    //
    //    assertEquals("There should be one dependency for the resource: /depTest/test3/r1",
    //            1, dependencies1.length);
    //
    //    assertTrue("/depTest/test3/r2 should be a dependency of /depTest/test3/r1",
    //            dependencies1[0].getDependencyPath().startsWith("/depTest/test3/r2"));
    //
    //    DependencyChain[] dependencies2 = dependencies1[0].getDependencies();
    //
    //    assertEquals("There should be one dependency for the resource: /depTest/test3/r2",
    //            1, dependencies2.length);
    //
    //    assertTrue("/depTest/test3/r3 should be a dependency of /depTest/test3/r2",
    //            dependencies2[0].getDependencyPath().startsWith("/depTest/test3/r3"));
    //
    //    DependencyChain[] dependencies3 = dependencies2[0].getDependencies();
    //
    //    assertEquals("There should be two dependencies for the resource: /depTest/test3/r3",
    //            2, dependencies3.length);
    //
    //    boolean r4Found = false;
    //    boolean r5Found = false;
    //    for (DependencyChain dependency : dependencies3) {
    //        if (dependency.getDependencyPath().startsWith("/depTest/test3/r4")) {
    //            r4Found = true;
    //        } else if (dependency.getDependencyPath().startsWith("/depTest/test3/r5")) {
    //            r5Found = true;
    //        }
    //    }
    //
    //    assertTrue("/depTest/test3/r4 should be a dependency of /depTest/test3/r3", r4Found);
    //    assertTrue("/depTest/test3/r5 should be a dependency of /depTest/test3/r3", r5Found);
    //
    //    DependentChain[] dependents1 = registry.getAllDependents("/depTest/test3/r5");
    //
    //    assertEquals("There should be one dependent for the resource: /depTest/test3/r5",
    //            1, dependents1.length);
    //
    //    assertTrue("/depTest/test3/r3 should be a dependent of /depTest/test3/r5",
    //            dependents1[0].getDependentPath().startsWith("/depTest/test3/r3"));
    //
    //    DependentChain[] dependents2 = dependents1[0].getDependents();
    //
    //    assertEquals("There should be one dependent for the resource: /depTest/test3/r3",
    //            1, dependents2.length);
    //
    //    assertTrue("/depTest/test3/r2 should be a dependent of /depTest/test3/r3",
    //            dependents2[0].getDependentPath().startsWith("/depTest/test3/r2"));
    //
    //    DependentChain[] dependents3 = dependents2[0].getDependents();
    //
    //    assertEquals("There should be one dependent for the resource: /depTest/test3/r2",
    //            1, dependents3.length);
    //
    //    assertTrue("/depTest/test3/r1 should be a dependent of /depTest/test3/r2",
    //            dependents3[0].getDependentPath().startsWith("/depTest/test3/r1"));
    //}
    //
    //private boolean containsString(String[] array, String value) {
    //
    //    boolean found = false;
    //    for (String anArray : array) {
    //        if (anArray.startsWith(value)) {
    //            found = true;
    //            break;
    //        }
    //    }
    //
    //    return found;
    //}

    // todo: uncomment below part after completing the associations
    public void testSettingDependenciesInResources() throws RegistryException {

        Resource r1 = registry.newResource();
        r1.setContent("some content for first r1".getBytes());
        String path = registry.put("/depTest/test1/r1", r1);
        r1 = registry.get(path);

        Resource r2 = registry.newResource();
        r2.setContent("this is dependent on r1".getBytes());
        path = registry.put("/depTest/test1/r2", r2);
        r2 = registry.get(path);
        registry.addAssociation(Association.DEPENDENCY, r2.getPath() ,"/depTest/test1/r1" );
        registry.addAssociation(Association.DEPENDENCY, r1.getPath() ,"/depTest/test1/r2");


        Resource r21 = registry.get("/depTest/test1/r1");
        Resource r22 = registry.get("/depTest/test1/r2");
        Association association [] = registry.getAllAssociations(r21.getPath()) ;
        assertNotNull(association);
        boolean found = false;
        for (Association association1 : association) {
            if ("/depTest/test1/r2".equals(association1.getDestinationPath())) {
                found = true;
            }
        }
        assertTrue(found);
        association = registry.getAllAssociations(r22.getPath()) ;
        assertNotNull(association);
        found = false;
        for (Association association1 : association) {
            if ("/depTest/test1/r1".equals(association1.getDestinationPath())) {
                found = true;
            }
        }
        assertTrue(found);
    }

    public void testSettingDependenciesFromAPI() throws RegistryException {

        Resource r1 = registry.newResource();
        r1.setContent("some content for second r1".getBytes());
        registry.put("/depTest/test2/r1", r1);

        Resource r2 = registry.newResource();
        r2.setContent("this is dependent on r2".getBytes());
        registry.put("/depTest/test2/r2", r2);

        registry.addAssociation(Association.DEPENDENCY, "/depTest/test2/r2", "/depTest/test2/r1");
        registry.addAssociation(Association.DEPENDENCY, "/depTest/test2/r1" ,"/depTest/test2/r2");

        Resource r21 = registry.get("/depTest/test2/r1");
        Resource r22 = registry.get("/depTest/test2/r2");
        Association association [] = registry.getAllAssociations(r21.getPath()) ;
        assertNotNull(association);
        boolean found = false;
        for (Association association1 : association) {
            if ("/depTest/test2/r2".equals(association1.getDestinationPath())) {
                found = true;
            }
        }
        assertTrue(found);
        association = registry.getAllAssociations(r22.getPath()) ;
        assertNotNull(association);
        found = false;
        for (Association association1 : association) {
            if ("/depTest/test2/r1".equals(association1.getDestinationPath())) {
                found = true;
            }
        }
        assertTrue(found);
    }
}
